﻿
function XUB_RefreshOptionVariables()

	XUB_BUTTON_SPACING = XUB_OptionsButtonSpacingSlider:GetValue();
	XUB_UPDATERATE = XUB_OptionsUpdateRateSlider:GetValue();
	XUB_GROUPSPACING = XUB_OptionsGroupSpacingSlider:GetValue();

	XUB_ENABLE_ALPHA = XUB_OptionsEnabledSlider:GetValue();
	XUB_BUFFED_ALPHA = XUB_OptionsBuffedSlider:GetValue();
	XUB_COOLDOWN_ALPHA = XUB_OptionsCooldownSlider:GetValue();
	XUB_NOMANA_ALPHA = XUB_OptionsOutOfManaSlider:GetValue();
	XUB_OUTOFRANGE_ALPHA = XUB_OptionsOutOfRangeSlider:GetValue();
    XUB_INVALID_ALPHA = XUB_OptionsFarOutOfRangeSlider:GetValue();

    XUB_BLINKRATE = XUB_OptionsBlinkRateSlider:GetValue();

	XUB_ANCHOR = XUB_OptionsAnchorText:GetText();

	XUB_XOFFSET = XUB_OptionsXOffsetSlider:GetValue();
	XUB_YOFFSET = XUB_OptionsYOffsetSlider:GetValue();

	XUB_TOOLTIPS = XUB_OptionsToolTipOptionText:GetText();

	XUB_COLORUSAGE = XUB_OptionsColorUsageText:GetText();

    XUB_HEALACTION = XUB_OptionsHealActionText:GetText();

    XUB_QUEUESIZE = XUB_OptionsRefreshQueueSizeSlider:GetValue();
    XUB_CHANGEDELAY = XUB_OptionsChangeDelaySlider:GetValue();

    if ( XUB_OptionsCountdown:GetChecked() ) then
        XUB_COUNTDOWN = 1;
    else
        XUB_COUNTDOWN = 0;
    end
    
    if ( XUB_OptionsCooldownSpinner:GetChecked() ) then
        XUB_USE_BUILTIN_COOLDOWN = 1;
    else
        XUB_USE_BUILTIN_COOLDOWN = 0;
    end
    
    if ( XUB_OptionsGlobalDim:GetChecked() ) then
        XUB_USE_GLOBALDIM = 1;
    else
        XUB_USE_GLOBALDIM = 0;
    end
    
    if ( XUB_OptionsGlobalCooldown:GetChecked() ) then
        XUB_ShowGlobalCooldown = 1;
    else
        XUB_ShowGlobalCooldown = nil;
    end
    
    if ( XUB_OptionsShowDecimalValues:GetChecked() ) then
        XUB_ShowDecimals = 1;
    else
        XUB_ShowDecimals = nil;
    end

end

function XUB_PrepareOptionVariables()

	XUB_OptionsButtonSpacingSlider:SetValue(XUB_BUTTON_SPACING);
	XUB_OptionsUpdateRateSlider:SetValue(XUB_UPDATERATE);
	XUB_OptionsGroupSpacingSlider:SetValue(XUB_GROUPSPACING);

	XUB_OptionsEnabledSlider:SetValue(XUB_ENABLE_ALPHA);
	XUB_OptionsBuffedSlider:SetValue(XUB_BUFFED_ALPHA);
	XUB_OptionsCooldownSlider:SetValue(XUB_COOLDOWN_ALPHA);
	XUB_OptionsOutOfManaSlider:SetValue(XUB_NOMANA_ALPHA);
	XUB_OptionsOutOfRangeSlider:SetValue(XUB_OUTOFRANGE_ALPHA);
    XUB_OptionsFarOutOfRangeSlider:SetValue(XUB_INVALID_ALPHA);

    XUB_OptionsBlinkRateSlider:SetValue(XUB_BLINKRATE);

	XUB_OptionsAnchorText:SetText(XUB_ANCHOR);

	XUB_OptionsXOffsetSlider:SetValue(XUB_XOFFSET);
	XUB_OptionsYOffsetSlider:SetValue(XUB_YOFFSET);

    XUB_OptionsRefreshQueueSizeSlider:SetValue(XUB_QUEUESIZE);
    XUB_OptionsChangeDelaySlider:SetValue(XUB_CHANGEDELAY);

	if ( XUB_TOOLTIPS == nil ) then
		XUB_TOOLTIPS = "Always";
	end

	XUB_OptionsToolTipOptionText:SetText(XUB_TOOLTIPS);

	if ( XUB_COLORUSAGE == nil ) then
		XUB_COLORUSAGE = "Transparency";
	end
	XUB_OptionsColorUsageText:SetText(XUB_COLORUSAGE);

    if ( XUB_HEALACTION == nil ) then
        XUB_HEALACTION = "Show as Disabled";
    end
    XUB_OptionsHealActionText:SetText(XUB_HEALACTION);

    XUB_OptionsCountdown:SetChecked(XUB_COUNTDOWN);

    XUB_OptionsCooldownSpinner:SetChecked(XUB_USE_BUILTIN_COOLDOWN);
    
    XUB_OptionsGlobalDim:SetChecked(XUB_USE_GLOBALDIM);
    
    XUB_OptionsGlobalCooldown:SetChecked(XUB_ShowGlobalCooldown);
    
    XUB_OptionsShowDecimalValues:SetChecked(XUB_ShowDecimals);

end


-- XUB_Percent( XUB_OptionsAlphaEnabledSlider , XUB_OptionsAlphaEnabledLabelLabel );
function XUB_SliderPercent(aSlider)

	local s = getglobal( "XUB_Options" .. aSlider .. "Slider" );
	local l = getglobal( "XUB_Options" .. aSlider .. "LabelLabel" );
	local high = getglobal( "XUB_Options" .. aSlider .. "SliderHigh" );
	local low = getglobal( "XUB_Options" .. aSlider .. "SliderLow" );

	local v = s:GetValue() * 100;
	l:SetText(string.format("%3.0f",v) .. "%" );
	high:SetText( "100%" );
	low:SetText( "0%" );
end



function XUB_SliderLowHigh(aSlider,aLow,aHigh,aMultiplier,aFormat,aEdit)

	local s = getglobal( "XUB_Options" .. aSlider .. "Slider" );
	local l = getglobal( "XUB_Options" .. aSlider .. "LabelLabel" );
	local high = getglobal( "XUB_Options" .. aSlider .. "SliderHigh" );
	local low = getglobal( "XUB_Options" .. aSlider .. "SliderLow" );

	local v = s:GetValue() * aMultiplier;
	l:SetText(string.format(aFormat,v) );
	high:SetText( aHigh );
	low:SetText( aLow );

    if ( aEdit ~= nil ) then
        aEdit:SetText(v);
    end
end

function XUB_Scroll(aSlider,aAmount)
    local s = getglobal( "XUB_Options" .. aSlider .. "Slider" );
    s:SetValue(s:GetValue() + aAmount * s:GetValueStep() );
end

function XUB_ScrollVertical(aSlider,aAmount)
    local s = getglobal( aSlider .. "Slider" );
    s:SetValue(s:GetValue() - aAmount * s:GetValueStep() );
end

function XUB_ColorSelect()
    local R,G,B = ColorPickerFrame:GetColorRGB();
end
function XUB_ColorCancel(prevvals)
    local R,G,B = unpack(prevvals)
end

function XUB_SeletColor(aTexture)
    ColorPickerFrame.func = XUB_ColorSelect
    ColorPickerFrame.cancelFunc = XUB_ColorCancel

    ColorPickerFrame.hasOpacity = true;
    --ColorPickerFrame.previousValues = aTexture:GetColorRGB();
    ColorPickerFrame:Show();
end