﻿
--
-- This function identifies the first 9 spells in a players spell box
-- and initializes the rest of the form.
--  	XUB_DefaultButtons

function XUB_SS_OnShow()

	XUB_GenerateDefaultSpellsAsList()

	XUB_SelectSpellListSliderSlider:SetMinMaxValues(1,#XUB_DefaultButtonsArray+#XUB_ConfigButtons-8);
	XUB_SelectSpellListSliderSlider:SetValue(1);
	XUB_SS_ShowSpells(1);
end

function XUB_SS_ShowSpells(aIndex)
	for i=0,8 do
		XUB_SS_ShowASpell(i+1,aIndex+i);
	end
end

function XUB_SS_ShowASpell(aPosition,aEntryID)

	local myLabel = getglobal("XUB_SelectSpellListLabel" .. aPosition .. "Label" );
	local myTexture = getglobal("XUB_SelectSpellListTexture" .. aPosition .. "Texture" );

	local mySelectedLabel = getglobal("XUB_SelectSpellListLabel0Label" );
	local mySelectedTexture = getglobal("XUB_SelectSpellListTexture0Texture" );
	
	myTexture:SetTexture( XUB_SS_GetTexture(aEntryID) );
	myLabel:SetText( XUB_SS_GetEntryText(aEntryID) );
	
	if ( XUB_SS_SelectedSpell == aEntryID ) then
		mySelectedTexture:SetTexture( XUB_SS_GetTexture(aEntryID) );
		mySelectedLabel:SetText( XUB_SS_GetEntryText(aEntryID) );

		myTexture:SetVertexColor(0.3,0.3,0.3);
	else
		myTexture:SetVertexColor(1,1,1);
	end
	
end

function XUB_SS_GetTexture(aEntryID)
    local myEntry;
    
    if ( aEntryID <= #XUB_DefaultButtonsArray ) then
        myEntry = XUB_DefaultButtonsArray[aEntryID];
    else
        myEntry = XUB_ConfigButtons[aEntryID-#XUB_DefaultButtonsArray];
    end
    
    
    if ( myEntry[2] == "macro" ) then
        -- Required call		
		GetNumMacroIcons();
		-- aThreshold holds the id for the macro.
		return GetMacroIconInfo( myEntry[3] );
    elseif ( myEntry[2] == "use" ) then
        local USEitemName, USEitemLink, USEitemRarity, USEitemLevel, USEitemMinLevel, USEitemType, USEitemSubType, USEitemStackCount, USEitemEquipLoc, USEitemTexture = GetItemInfo(myEntry[3]) 

        if ( USEitemTexture == nil ) then
			USEitemTexture = "Interface\Icons\INV_Misc_QuestionMark";
		elseif ( USEitemTexture == "" ) then 
			USEitemTexture = "Interface\Icons\INV_Misc_QuestionMark";
		end
		
		return USEitemTexture;
    else
        return XUB_GetSpellTextureAndID( myEntry[3] , myEntry[4] );
    end
end

function XUB_SS_GetEntryText(aEntryID)

    local myEntry;
    
    if ( aEntryID <= #XUB_DefaultButtonsArray ) then
        myEntry = XUB_DefaultButtonsArray[aEntryID];
    else
        myEntry = XUB_ConfigButtons[aEntryID-#XUB_DefaultButtonsArray];
    end
    
    if ( myEntry[2] == "macro" ) then
        return myEntry[4];
    elseif ( myEntry[2] == "use" ) then
        return "Use item '" .. myEntry[3] .. "'";
    else
        local myBaseText;
        if ( myEntry[4] == "" ) then   -- Rank
            myBaseText = myEntry[3]
        else
            myBaseText = myEntry[3] .. " - " .. myEntry[4]
        end
        
        if ( myEntry[2] == "spell" ) then
            return myBaseText;
        elseif ( myEntry[2] == "always" ) then
            return myBaseText .. "[Show always]";
        elseif ( myEntry[2] == "spellblink" ) then
            return myBaseText .. "[Start blinking if not buffed with spell]";
        elseif ( myEntry[2] == "health" ) or ( myEntry[2] == "heal" ) then
            local myThreshold = tonumber(myEntry[5]);
            if ( myThreshold > 0 ) then
                return myBaseText .. " [Show if damage > " .. myThreshold .. "]";
            else
                return myBaseText .. " [Show if health < " .. -myThreshold .. "]";
            end
        elseif ( myEntry[2] == "buff" ) then
            return myBaseText .. " [Hide if also buffed with " .. myEntry[5] .. "]";
        elseif ( myEntry[2] == "debuff" ) then
            return myBaseText .. " [Show if debuffed with " .. myEntry[5] .. "]";
        elseif ( myEntry[2] == "buffblink" ) then
            return myBaseText .. " [Hide if also buffed with " .. myEntry[5] .. ".  If shown, start blinking.]";
        elseif ( myEntry[2] == "debuffblink" ) then
            return myBaseText .. " [Show if debuffed with " .. myEntry[5] .. ".  If shown, start blinking.]";
        end
    end

end

function XUB_SS_AppendGroup(aEntryID)
    --XUB_OptionsAnchorText:SetText(XUB_ANCHOR);
    --XUB_ANCHOR = XUB_OptionsAnchorText:GetText();
    
    if ( aEntryID <= #XUB_DefaultButtonsArray ) then
        myEntry = XUB_DefaultButtonsArray[aEntryID];
    else
        myEntry = XUB_ConfigButtons[aEntryID-#XUB_DefaultButtonsArray];
    end
    
    local myGroupName = XUB_SelectSpellGroupName:GetText();
    local myGroupText = XUB_SelectSpellTextPanelGroupEdit:GetText();
    
    if ( myGroupName == "" ) then
        myGroupName = "UnknownGroup";
    end
    
    if ( myGroupText ) then
        XUB_SelectSpellTextPanelGroupEdit:SetText( myGroupText .. "\n" .. myGroupName .. "," .. myEntry[1] .. "," .. strtrim(XUB_SelectSpellTargetText:GetText()) );
    else
        XUB_SelectSpellTextPanelGroupEdit:SetText( myGroupName .. "," .. myEntry[1] .. "," .. strtrim(XUB_SelectSpellTargetText:GetText()) );
    end    
    
end


function XUB_SS_OnValueChanged()
    local myItemNbr = XUB_SelectSpellListSliderSlider:GetValue();
	XUB_SS_ShowSpells(myItemNbr);
end

function XUB_SS_SetSpell(aPosition)
	XUB_SS_SelectedSpell = XUB_SelectSpellListSliderSlider:GetValue() + aPosition - 1;
	XUB_SS_OnValueChanged();
    
    XUB_SS_AppendGroup(XUB_SS_SelectedSpell);
end







function XUB_GetSpellName(aSpellID)

	local myTable = { strsplit(",",XUB_DefaultButtons[aSpellID]) };
	
	if ( myTable[4] == nil ) then
		return myTable[3],""
	else
		return myTable[3],myTable[4]
	end
end

function XUB_GetSpellTextureAndLabel(aSpellID)
	local SpellName,Rank = XUB_GetSpellName(aSpellID);
	
	return XUB_GetSpellTextureAndID(SpellName,Rank),XUB_GetSpellRankText(SpellName,Rank);
end

function XUB_GetSpellRankText(SpellName,Rank)
	if ( Rank == "" ) then
		return SpellName;
	else
		return SpellName .. " - " .. Rank;
	end
end;
