-- The idea of eXtreme Unit Buttons (XUB) orginally based on Party Buttons who was trying to replicate the broken
-- mod called GroupButtons written by Loz.
--
-- Party Bars used the Action Button Bars which as a limit of 120.  XUB has no such limit, and will be made to be
-- completely configurable.
--
-- All orgininal code and content were developed by Elenesski.   Copyright Disclaimer: While you are free to copy
-- anything I've done here, the only think I ask is that you acknowledge the source, and where you got the
-- code.
--
-- Some modifications have been made by tayedaen since versions > 1.6
--
-- Creation Date : 2008-11-04
-- Version       : 1.9 RC 7
--
-- Acknowledgements: 2007-Jan-12 PartyBars - For showing me that a GroupButtons-like mod was possible.
--                   2007-Jan-27 Shaymon   - For identifying Spells with quotes don't work.  Fixed in v0.9.01
--                   2007-Jan-28 Borohir   - For providing GameTooltip code which allows tooltips to be added -- Now with additional features.
--                   2007-Jan-28 Borohir   - For providing code to show colors -- Now an option.
--

--
-- Saved Variables
--
XUB_ENABLE_ALPHA     = 1;
XUB_BUFFED_ALPHA     = 0.2;
XUB_GLOBLADIM_ALPHA  = 0.05;
XUB_COOLDOWN_ALPHA   = 0.5;
XUB_NOMANA_ALPHA     = 0.05;
XUB_OUTOFRANGE_ALPHA = 0.2;
XUB_INVALID_ALPHA    = 0;

XUB_GROUPSPACING = 20;
XUB_BUTTON_SCALE = 0.35;
XUB_BUTTON_SPACING = 1;
XUB_UPDATERATE = 0.5;

XUB_QUEUESIZE = 10;         -- How many units are updated per refresh?
XUB_CHANGEDELAY = 5;        -- How many second delay when party/raid members change?

XUB_ANCHOR = "TOPRIGHT";

XUB_XOFFSET = 0;
XUB_YOFFSET = 0;

XUB_ConfigButtons = {}
XUB_ConfigGroups = {}
XUB_ConfigProfiles = {}

XUB_CurrentProfile = "";
XUB_FirstProfile = "";

XUB_UNITFRAMES = "agUnitFrames";        -- ??????

XUB_TOOLTIPS = "Always";
XUB_COLORUSAGE = "Color Coded";   --Red=Range,Ochre=Buffed,Purple=Cooldown,Cobalt=Mana

XUB_COUNTDOWN = 0;
XUB_HEALACTION = "Show as Buffed";

XUB_UF_Player = "PlayerFrame";
XUB_UF_PlayerPet = "PlayerFramePetFrame";
XUB_UF_Party = "PartyMemberFrame#";
XUB_UF_PartyPet = "PartyMemberFrame#PetFrame";
XUB_UF_Target = "TargetFrame";
XUB_UF_Focus = "FocusFrame";
XUB_UF_DropDownDefault = "Blizzard";

XUB_UF_WIDTH_Float = "20";
XUB_UF_WIDTH_Player = "20";
XUB_UF_WIDTH_PlayerPet = "20";
XUB_UF_WIDTH_Party = "20";
XUB_UF_WIDTH_PartyPet = "20";
XUB_UF_WIDTH_Target = "20";
XUB_UF_WIDTH_Focus = "20";

XUB_UF_RaidFrames = "n/a";   -- Name of your Raid Frames (eg Blizzard, CTRA etc.)
XUB_UF_WIDTH_RaidMember = "20";
XUB_UF_WIDTH_RaidPet = "20";

XUB_UF_CUSTOMNAME1 = "";
XUB_UF_CUSTOMFRAME1 = "";
XUB_UF_CUSTOMWIDTH1 = "20";
XUB_UF_CUSTOMNAME2 = "";
XUB_UF_CUSTOMFRAME2 = "";
XUB_UF_CUSTOMWIDTH2 = "20";
XUB_UF_CUSTOMNAME3 = "";
XUB_UF_CUSTOMFRAME3 = "";
XUB_UF_CUSTOMWIDTH3 = "20";
XUB_UF_CUSTOMNAME4 = "";
XUB_UF_CUSTOMFRAME4 = "";
XUB_UF_CUSTOMWIDTH4 = "20";
XUB_UF_CUSTOMNAME5 = "";
XUB_UF_CUSTOMFRAME5 = "";
XUB_UF_CUSTOMWIDTH5 = "20";

XUB_BLINKRATE = 0.5;
XUB_PlayerPartyUnits = {};          -- Names and frames of players and pets in party
XUB_PlayerRaidUnits = {};           -- Names and frames of players and pets in raid

XUB_PR_groups = 20;

XUB_DEBUG = 0;

--TAYEDAEN
XUB_USE_NEWGROUPCHECK = 1;
XUB_USE_BUILTIN_COOLDOWN = 1;
XUB_MouseOveredButton = nil;
XUB_MakeInitialisation = 1;
XUB_ButtonSize = 64;
XUB_USE_GLOBALDIM = 0;
XUB_GLOBALDIM_active = 0;
XUB_ShowGlobalCooldown = nil;
XUB_ShowDecimals = nil;
XUB_DelayTime_after_automaticProfileChange = 0;
XUB_DelayTime_after_manualProfileChange = 3;
XUB_DelayTime = 3;
XUB_ChangesToApplyAfterCombat=nil;
XUB_ShowPartyInRaid = nil;

XUB_UseRightButton = "RightButtonUp"
XUB_UseMiddleButton = "MiddleButtonUp"
XUB_UseButton4 = "Button4Up"
XUB_UseButton5 = "Button5Up"

XUB_LEARNED_SPELL_IN_TAB = nil
XUB_PARTY_MEMBERS_CHANGED = nil
XUB_RAID_ROSTER_UPDATE = nil
XUB_ProfileChange = nil

--Drome
XUB_ConversionLevel = 1.5;

-- @@  added pitbull support

XUB_PitBull_5Man_Lut =
 { party1="raid1",partypet1="raidpet1",party1target="raid1target",
 party2="raid2",partypet2="raidpet2",party2target="raid2target",
 party3="raid3",partypet3="raidpet3",party3target="raid3target",
 party4="raid4",partypet4="raidpet4",party4target="raid4target"};
-- 5Man_Lut - lookup table - to support the "Treat 5 man raid as party" option in Pitbull

--
-- End of Saved Variables
--
XUB_FRAME_STRATA = "LOW";
XUB_BUTTON_STRATA = "NORMAL";
XUB_LastHealthTarget = 0;       -- Approximate health points left on the target
XUB_HealthLeftTarget = 0;       -- Exact health of target in % (after last damage event)
XUB_LastDamageTarget = 0;       -- Damage amount of last attack

XUB_UnitList = {}               -- contains all units where frames are attached to (player, target, focus, party1, ..)
XUB_Units = {}                  -- Keeps track of the button id last used by a given unit frame
XUB_RaidTable = {};             -- Keeps track of the frames that correspond to the raid#'s
XUB_Buttons = {}                -- Keeps track of the last button created for the unit
XUB_RowStart = {}               -- Keeps track of the first button in a row for a unit
XUB_DefaultButtons = {}         -- System Buttons
XUB_DefaultButtonsArray = {}    -- System Buttons (in Array Form)
XUB_ConfigSpells = {}           -- Spells used in the C2 configuration dialogs
XUB_ButtonQueue = {}            -- Created Buttons
XUB_SelectedConfigSpell = 0     -- The spell the is selected in the list of ConfigSpells

XUB_CurrentScenario = "";       -- The name of the current scenario
XUB_Scenario = {}               -- Keeps track of the scenarios that have been defined
XUB_Category = {}               -- Keeps track of the categories that are used

XUB_SS_SelectedSpell = 0;
XUB_SM_SelectedMacro = 0;

XUB_NextUpdate = 25;            -- Constantly modified variable, identifying when the next update takes place

XUB_APPLY_DELAY = 5;        -- # seconds to wait before updating the screen with a party/raid change
XUB_QUEUEPTR    = 9999;     -- PTR in the updatequeue
XUB_UPDATEUNITS = {};       -- Which units have frames which require updating

-- XUB COLOR DEFINITION BLOCK
-- Colorcodes : see http://www.wowwiki.com/User:Tinkerer/Colour
-- Take the R G B values from this page, and divide them by 255
-- Next lines set the colors for the different states if 'Color coded' is used instead of 'Transparency'
XUB_COLORS = { select       = { r = 0.8, g = 0.8, b = 0.8 },
               c_range      = { r = 0.8, g = 0.1, b = 0.1 },    -- redish
               c_outofmana  = { r = 0.0, g = 0.28, b = 0.67 },  -- cobalt
               c_cooldown   = { r = 0.4, g = 0.0, b = 0.59 },   -- purple
               c_buffed     = { r = 0.8, g = 0.46, b = 0.13 },  -- ochre
               c_globaldim  = { r = 0.59, g = 1.0, b = 0.59 },  -- mint
--               red    = { r = 1.0, g = 0.0, b = 0.0 },
--               blue   = { r = 0.0, g = 0.0, b = 1.0 },
--               green  = { r = 0.0, g = 1.0, b = 0.0 },
--               purple = { r = 0.4, g = 0.0, b = 0.59 },     -- 102      0     153
--               cobalt   = { r = 0.0, g = 0.28, b = 0.67 },  --   0     71     171
--               mint   = { r = 0.59, g = 1.0, b = 0.59 },    -- 152    255     152
--               mustard = { r = 1.0, g = 0.85, b = 0.34 },   -- 255    219      88
--               ochre  = { r = 0.8, g = 0.46, b = 0.13 },    -- 204    119      34
}

STATE_ENABLED    = 1;
STATE_HEALTHOFF  = 2;
STATE_BUFFED     = 3;
STATE_DIMMED     = 4;
STATE_COOLDOWN   = 5;
STATE_NO_ITEMS   = 6;
STATE_OUTOFMANA  = 7;
STATE_OUTOFRANGE = 8;
STATE_INVALID    = 9;

XUB_MakeButtons = 0;

XUB_TIME = 0;

--
-- This table identifies which units on the screen require updating.  Technically modifying this table
-- would allow you to support raids, but I have something different up my sleeve for raid support because
-- when my guild raids in large groups a priest is responsible for different things.  I want the raid
-- support to be able to support those decisions by showing only buttons on units I'm responsible for
-- and ignoring all the rest.
--

function XUB_OnLoad(self)

    XUB_WeaponTooltip = CreateFrame("GameTooltip", "XUB_ParseToolTip", nil, "GameTooltipTemplate");
    XUB_WeaponTooltip:SetOwner(WorldFrame, "ANCHOR_NONE");

    -- WotLK
    XUB_GameTooltip = CreateFrame("GameTooltip", "XUB_ShowToolTip", nil, "GameTooltipTemplate");
    local myFontSize = 20;
    local myScale = 0.7 * GameTooltip:GetScale();
    XUB_GameTooltip:SetScale(myScale);


--    XUB_Initialize_CountdownFont();

    -- Setup the slash commands

    SLASH_XUB1 = "/XUB";
    SLASH_XUB2 = "/xub";
    SlashCmdList["XUB"] = function(msg)
        XUB_SlashCommandHandler(msg);
    end

-- better let's do the initialization after "PLAYER_ENTERING_WORLD"
--    InitializeXUB_UnitList();
--    XUB_InitializeBuildTables();
--    XUB_GenerateDefaultSpellsAsList();

    self:SetScript("OnEvent",XUB_OnEvent);

    self:RegisterEvent("PLAYER_ENTERING_WORLD");
    if ( XUB_USE_GLOBALDIM == 1 ) then
        self:RegisterEvent("UNIT_SPELLCAST_START");
    end

    ShowMessage( GetAddOnMetadata("eXtremeUnitButtons","Title") .. " Version " .. GetAddOnMetadata("eXtremeUnitButtons","Version") .. " Loaded (/XUB - for options)" )

--    collectgarbage("stop");
end

function InitializeXUB_UnitList()

    -- Initialize the tables
    XUB_UnitList = {};

    table.insert(XUB_UnitList,"player");
    table.insert(XUB_UnitList,"playerpet");

    table.insert(XUB_UnitList,"target");
    table.insert(XUB_UnitList,"focus");

    table.insert(XUB_UnitList,"party1");
    table.insert(XUB_UnitList,"party2");
    table.insert(XUB_UnitList,"party3");
    table.insert(XUB_UnitList,"party4");

    table.insert(XUB_UnitList,"partypet1");
    table.insert(XUB_UnitList,"partypet2");
    table.insert(XUB_UnitList,"partypet3");
    table.insert(XUB_UnitList,"partypet4");


    if ( XUB_UF_CUSTOMNAME1 ~= "" ) then
        table.insert(XUB_UnitList,XUB_UF_CUSTOMNAME1);
    end
    if ( XUB_UF_CUSTOMNAME2 ~= "" ) then
        table.insert(XUB_UnitList,XUB_UF_CUSTOMNAME2);
    end
    if ( XUB_UF_CUSTOMNAME3 ~= "" ) then
        table.insert(XUB_UnitList,XUB_UF_CUSTOMNAME3);
    end
    if ( XUB_UF_CUSTOMNAME4 ~= "" ) then
        table.insert(XUB_UnitList,XUB_UF_CUSTOMNAME4);
    end
    if ( XUB_UF_CUSTOMNAME5 ~= "" ) then
        table.insert(XUB_UnitList,XUB_UF_CUSTOMNAME5);
    end

    for i=1,40 do
        table.insert(XUB_UnitList,"raid" .. i );
        table.insert(XUB_UnitList,"raidpet" .. i );
    end

    table.insert(XUB_UnitList,"float");

--    table.insert(XUB_UnitList,"none");
end

function XUB_InitializeBuildTables()

    XUB_Units = {}
    XUB_Buttons = {}
    XUB_RowStart = {}

    local myUnit
    for i=1,#XUB_UnitList do
        myUnit = XUB_UnitList[i];

        XUB_Units[myUnit] = 0;
        XUB_Buttons[myUnit] = nil;
        XUB_RowStart[myUnit] = nil;

    end
end

function XUB_RemoveButtons()

    local myUnit
    local aButton
    local aButtonName
    for i=1,#XUB_UnitList do
        myUnit = XUB_UnitList[i];
--        ShowMessage( "XUB-debug: REMOVING buttons for unit '" .. myUnit .. "' with "..CCC(XUB_Units[myUnit]).." units");
        if ( XUB_Units[myUnit] > 0 ) then
            for j = 1,XUB_Units[myUnit] do
                aButtonName = XUB_GenerateButtonName(myUnit,j);
                aButton = getglobal(aButtonName);
--                ShowMessage( "XUB-debug: REMOVING '" .. aButtonName .. "'");
                aButton.isActive = 0;
                aButton:Disable();
                aButton:Hide();
            end
            XUB_Units[myUnit] = 0;
            XUB_Buttons[myUnit] = nil;
            XUB_RowStart[myUnit] = nil;
        end
    end

end

function XUB_RemoveButtons_for_SingleUnit(aUnit)

    local aButton
    --ShowMessage( "XUB-debug: REMOVING buttons for " .. CCC(aUnit));
    for j = 1,XUB_Units[aUnit] do       --search via DESTINATION UNIT
        aButton = getglobal(XUB_GenerateButtonName(aUnit,j));
        --ShowMessage( "XUB-debug: REMOVING '" .. XUB_GenerateButtonName(aUnit,j) .. "'");
        aButton.isActive = 0;
        aButton:Disable();
        aButton:Hide();
    end
    XUB_Units[aUnit] = 0;
    XUB_Buttons[aUnit] = nil;
    XUB_RowStart[aUnit] = nil;

    local j=1
    while ( XUB_ButtonQueue[j] ) do       --search via BAR/Frame attached to
        if XUB_ButtonQueue[j].Bar == aUnit then
            XUB_ButtonQueue[j].isActive = 0;
            XUB_ButtonQueue[j]:Disable();
            XUB_ButtonQueue[j]:Hide();
            table.remove(XUB_ButtonQueue, j)
        else
            j = j + 1;
        end
    end
end

function XUB_DoFirstLoadInitialisation()

    if XUB_CurrentProfile ~= "" then    -- start conversion only if there is already something to convert
                                        -- This prevents conversion for first time users
        XUB_ConvertSaved();             -- conversion of saved variables from oder versions
    end

    InitializeXUB_UnitList();
    XUB_InitializeBuildTables();
    XUB_GenerateDefaultSpellsAsList();

    PBFrame:RegisterEvent("PARTY_MEMBERS_CHANGED");
    PBFrame:RegisterEvent("RAID_ROSTER_UPDATE");
    PBFrame:RegisterEvent("LEARNED_SPELL_IN_TAB");
    PBFrame:RegisterEvent("PLAYER_REGEN_ENABLED");
    if ( XUB_USE_GLOBALDIM == 1 ) then
        PBFrame:RegisterEvent("UNIT_SPELLCAST_START");
    end

    XUB_DelayTime = 3;                                  -- to reset it after a ReloadUI
    XUB_NextUpdate = XUB_DelayTime;                     -- to reset it after a ReloadUI
    PBFrame:SetScript("OnUpdate",XUB_OnUpdate);

    -- ShowMessage("XUB-debug: Initialisation finished");

end

function XUB_Initialize_Raidtable()

 if ( GetNumRaidMembers() > 0 ) then
    local testName, testFrame, testFrameUnit;

--    ShowMessage("XUB-debug: Starting XUB_Initialize_Raidtable()");

    XUB_RaidTable = {};

    if ( XUB_UF_RaidFrames == "CTRaid" ) then
        if ( CT_RA_UnitIDFrameMap ) then
            for r=1,GetNumRaidMembers() do
                testFrame = CT_RA_UnitIDFrameMap["raid" .. r]
                if ( testFrame ) then
                    XUB_RaidTable["raid" .. r] = testFrame.name;
                end
            end
        end
    elseif ( XUB_UF_RaidFrames == "XPerl" ) then
        if ( XPERL_RAIDGRP_PREFIX ) and (XPerl_Raid_OnLoad == nil) and (XPerl_Raid_GetUnitFrameByUnit) then
            for i = 1,GetNumRaidMembers() do
                testFrame = XPerl_Raid_GetUnitFrameByUnit("raid"..i);
                if ( testFrame ) then
                    XUB_RaidTable["raid" .. i] = testFrame:GetName();
                end
            end
        end
    elseif ( XUB_UF_RaidFrames == "agUnitFrames" ) then
        for g=1,20 do
            for u=1,10 do
                testName = "aUFgroup" .. g .. "UnitButton" .. u;
                testFrame = getglobal(testName);
                if ( testFrame ) then
                    testFrameUnit = testFrame:GetAttribute("unit");
                    if ( testFrameUnit ~= nil ) then
--                        if ( XUB_RaidTable[testFrameUnit] ~= nil ) then
--                            XUB_RaidTable[testFrameUnit] = XUB_RaidTable[testFrameUnit] .. "/" .. testName;
--                        else
                            XUB_RaidTable[testFrameUnit] = testName;
--                        end
                    else
                        break;
                    end
                end
            end
        end
    elseif ( XUB_UF_RaidFrames == "Blizzard" ) then
        for g=1,20 do
            for u=1,10 do
                testName = "RaidPullout" .. g .. "Button" .. u;
                testFrame = getglobal(testName);
                if ( testFrame ) then
                    testFrameUnit = testFrame.unit
                    if ( testFrameUnit ~= nil ) then
                        if ( XUB_RaidTable[testFrameUnit] ~= nil ) then
                            XUB_RaidTable[testFrameUnit] = XUB_RaidTable[testFrameUnit] .. "/" .. testName;
                        else
                            XUB_RaidTable[testFrameUnit] = testName;
                        end
                    else
                        break;
                    end
                end
            end
        end
    elseif ( XUB_UF_RaidFrames == "PerfectRaid" ) then
        for g=1,XUB_PR_groups do
            for u=1,40 do
                testName = "PRHeader" .. g .. "UnitButton" .. u;
                testFrame = getglobal(testName);
                if ( testFrame ) then
                    --testFrameUnit = testFrame.unit
                    --ShowMessage("testFrameUnit1: " .. CCC(testFrameUnit));
                    testFrameUnit = testFrame:GetAttribute("unit")
                    --ShowMessage("testFrameUnit2: " .. CCC(testFrameUnit));
                    if ( testFrameUnit ~= nil ) then
--                        if ( XUB_RaidTable[testFrameUnit] ~= nil ) then
--                            XUB_RaidTable[testFrameUnit] = XUB_RaidTable[testFrameUnit] .. "/" .. testName;
--                        else
                            --ShowMessage("saving [" .. testFrameUnit .. "]: " .. testName);
                            XUB_RaidTable[testFrameUnit] = testName;
--                        end
                    else
                        break;
                    end
                end
            end
        end
    elseif ( XUB_UF_RaidFrames == "PitBull" ) then
        local piuf = PitBull.IterateUnitFrames;
        if piuf == nil then
           ShowMessage("PitBull Addon not found - [PitBull:IterateUnitFrames == nil]");
        else
         for c=1,20 do
               for u=1,10 do
                    testName = "PitBullCluster" .. c .. "UnitButton" .. u;
                    testFrame = getglobal(testName)
                    if ( testframe ) then
                        testFrameUnit = testFrame:GetAttribute("unit")
                        if ( testFrameUnit ~= nil ) then
                          if XUB_PitBull_5Man_Lut[testFrameUnit] then
                             test_unit = XUB_PitBull_5Man_Lut[testFrameUnit];
                          end
                          if ( XUB_RaidTable[testFrameUnit] ~= nil ) then
                             --ShowMessage("saving [" ..testFrameUnit .. "] " .. XUB_RaidTable[testFrameUnit]  .. "/" .. testName);
                             XUB_RaidTable[testFrameUnit] = XUB_RaidTable[testFrameUnit] .. "/" .. testName;
                          else
                             --ShowMessage("saving [" .. testFrameUnit .. "]" .. testName);
                             XUB_RaidTable[testFrameUnit] = testName;
                          end
                      end
                    end
              end
         end
      end
   elseif ( XUB_UF_RaidFrames == "PitBullFrameNames" ) then
      for u=1,40 do
        testName = "PBFN_" .. "raid" .. u;
        testFrame = getglobal(testName)
        testFrameUnit = "raid" .. u
        if ( testFrame ~= nil ) then
          if ( XUB_RaidTable[testFrameUnit] ~= nil ) then
             XUB_RaidTable[testFrameUnit] = XUB_RaidTable[testFrameUnit] .. "/" .. testName;
          else
             XUB_RaidTable[testFrameUnit] = testName;
          end
        end
      end
    end

--    ShowMessage("XUB-debug: Finished XUB_Initialize_Raidtable()");
 end

end

--
-- Event Handler .. this is just a laundry list of events
--
function XUB_OnEvent(self, event, ...)

    if (event == "PLAYER_ENTERING_WORLD") then
        -- This event means: All saved variables should have been loaded, and we should know if the user is in a group or raid

        --XUB_StopProfiling();

        XUB_DoFirstLoadInitialisation();
    elseif (event == "PLAYER_REGEN_ENABLED") then           -- Combat finished
        if  ( XUB_ChangesToApplyAfterCombat ) then
            XUB_ProfileChange = true;
            XUB_APPLY_DELAY = 3;     -- could also be: XUB_APPLY_DELAY = XUB_CHANGEDELAY, but I want to make sure combat has really finished
        end
    elseif (event == "PARTY_MEMBERS_CHANGED") then
        XUB_PARTY_MEMBERS_CHANGED = true;
        XUB_APPLY_DELAY = XUB_CHANGEDELAY;
    elseif (event == "RAID_ROSTER_UPDATE") then
        if XUB_UF_RaidFrames ~= "n/a" then
            XUB_RAID_ROSTER_UPDATE = true;
            XUB_APPLY_DELAY = XUB_CHANGEDELAY;
        end
    elseif (event == "LEARNED_SPELL_IN_TAB") then
        XUB_LEARNED_SPELL_IN_TAB = true;
        XUB_APPLY_DELAY = XUB_CHANGEDELAY;
    elseif (event == "UNIT_SPELLCAST_START") then
        if ( arg1 == "player" ) then
            XUB_GLOBALDIM_active = 1;
            self:UnregisterEvent("UNIT_SPELLCAST_START");
            self:RegisterEvent("UNIT_SPELLCAST_STOP");
            self:RegisterEvent("UNIT_SPELLCAST_FAILED");
            self:RegisterEvent("UNIT_SPELLCAST_INTERRUPTED");
            self:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED");
        end
    elseif (event == "UNIT_SPELLCAST_STOP") or
           (event == "UNIT_SPELLCAST_STOP") or
           (event == "UNIT_SPELLCAST_FAILED") or
           (event == "UNIT_SPELLCAST_INTERRUPTED") or
           (event == "UNIT_SPELLCAST_SUCCEEDED") then
        if ( arg1 == "player" ) then
            XUB_GLOBALDIM_active = 0;
            self:RegisterEvent("UNIT_SPELLCAST_START");
            self:UnregisterEvent("UNIT_SPELLCAST_STOP");
            self:UnregisterEvent("UNIT_SPELLCAST_FAILED");
            self:UnregisterEvent("UNIT_SPELLCAST_INTERRUPTED");
            self:UnregisterEvent("UNIT_SPELLCAST_SUCCEEDED");
        end
    end

end

function XUB_SetBackground(aFrame)
    aFrame:SetBackdrop({bgFile = "Interface/Tooltips/Nameplate-Glow",
                                edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
                                tile = true, tileSize = 16, edgeSize = 16,
                                insets = { left = 4, right = 4, top = 4, bottom = 4 }});
    aFrame:SetBackdropColor(0,0,0,1);
end


--Fired when an npc or player participates in combat and takes damage
--
--arg1 -- the UnitID of the entity
--arg2 -- Action,Damage,etc (e.g. DODGE, BLOCK, WOUND, MISS, PARRY, RESIST, ...)
--arg3 -- Critical/Glancing indicator (e.g. CRITICAL, CRUSHING, GLANCING)
--arg4 -- The numeric damage
--arg5 -- Damage type in numeric value (0 - physical; 1 - holy; 2 - fire; 4 - frost; 5 - shadow; 6 - arcane)
function XUB_MeasureDamage(aUnit,aEventType,aType,aAmount,aDamageType)

--    if ( GameTooltip:IsVisible() ) then
--        GameTooltip:Hide();
--    end


    if ( aUnit ~= "target" ) then
        return;
    elseif ( aEventType ~= "WOUND" ) then
        return;
    end

    XUB_LastHealthTarget = UnitHealth("target");
    XUB_LastDamageTarget = aAmount;

end

function XUB_Check_for_RaidChanges()

    local groupsize = GetNumRaidMembers();
    local changesApplied = nil
    local MyOldGroup = XUB_PlayerRaidUnits;

    if ( #XUB_PlayerPartyUnits > 0 ) then
    -- Player was/is  in a group
        if ( XUB_ShowPartyInRaid == nil) then
        -- Partyframes should be hidden
            for i=1,#XUB_PlayerPartyUnits do
                XUB_RemoveButtons_for_SingleUnit("party" .. i);     -- let's remove surplus buttons
                XUB_RemoveButtons_for_SingleUnit("partypet" ..i);   -- let's remove surplus buttons for pets too
            end
            XUB_PlayerPartyUnits = {}       -- then forget the frames of the party we have been in before
        end
    end

    XUB_PlayerRaidUnits = {}             -- could be replaced by setting surplus values to nil

    if ( groupsize < #MyOldGroup ) then           -- members have been REMOVED
        for i=#MyOldGroup,groupsize+1,-1 do
            XUB_RemoveButtons_for_SingleUnit("raid" .. i);   -- let's remove surplus buttons
--            XUB_RemoveButtons_for_SingleUnit("raidpet" ..i);   -- let's remove surplus buttons for their pets too
        end
        changesApplied = true;
    end

    local MyUnit, MyUnitName, MyUnitFrame, MyUnitPet, MyUnitPetName, MyUnitPetFrame;

    for i=1,groupsize do
        --ShowMessage("XUB-debug: Checking raid, i=" .. i )
        MyUnit = "raid" .. i;
        MyUnitName = UnitName(MyUnit)
        MyUnitFrame = XUB_RaidTable[MyUnit]
        if ( MyOldGroup[i] == nil ) or ( MyOldGroup[i][1] ~= MyUnit ) or ( MyOldGroup[i][2] ~= MyUnitName ) or ( MyOldGroup[i][3] ~= MyUnitFrame ) then
            XUB_RemoveButtons_for_SingleUnit(MyUnit);
            XUB_ApplyProfile_for_SingleUnit(XUB_CurrentProfile, "raid", i, MyUnitFrame);
--            XUB_ApplyProfile_for_SingleUnit(XUB_CurrentProfile, "raidpet", i, MyUnitFrame);
            changesApplied = true;
        end
--        XUB_PlayerRaidUnits[i] = { MyUnit, MyUnitName, MyUnitFrame, MyPetUnit, MyPetUnitName, MyUnitPetFrame }
        XUB_PlayerRaidUnits[i] = { MyUnit, MyUnitName, MyUnitFrame }
    end

    return changesApplied;
end

function XUB_Check_for_PartyChanges()

    local changesApplied = nil
    local MyOldGroup = XUB_PlayerPartyUnits;

    XUB_PlayerPartyUnits = {}             -- could be replaced by setting surplus values to nil

    local groupsize = GetNumPartyMembers();

    --ShowMessage("XUB-debug: groupsize" .. CCC(groupsize) .. "#MyOldGroup: " .. CCC(#MyOldGroup) )
    if ( groupsize < #MyOldGroup ) then           -- members have been REMOVED
        for i=#MyOldGroup,groupsize+1,-1 do
            XUB_RemoveButtons_for_SingleUnit("party" .. i);     -- let's remove surplus buttons
            XUB_RemoveButtons_for_SingleUnit("partypet" ..i);   -- let's remove surplus buttons for pets too
        end
        changesApplied = true;
    end

    local MyUnit, MyUnitName, MyUnitFrame, MyUnitPet, MyUnitPetName, MyUnitPetFrame

    for i=1,groupsize do
        --ShowMessage("XUB-debug: Checking party, i=" .. i )
        MyUnit = "party" .. i;
        MyUnitName = UnitName(MyUnit)
        MyUnitFrame = XUB_UF_Party:gsub("!!","0" .. i):gsub("!",i):gsub("#",i):gsub("@",1);
        MyUnitPet = "partypet" ..i;
        MyUnitPetName = UnitName(MyUnitPet);
        MyUnitPetFrame = XUB_UF_PartyPet:gsub("!!","0" .. i):gsub("!",i):gsub("#",i):gsub("@",1);
        if ( MyOldGroup[i] == nil ) or ( MyOldGroup[i][1] ~= MyUnit ) or ( MyOldGroup[i][2] ~= MyUnitName ) or ( MyOldGroup[i][3] ~= MyUnitFrame ) then
            XUB_RemoveButtons_for_SingleUnit(MyUnit);
            XUB_RemoveButtons_for_SingleUnit(MyUnitPet);  -- Drome
            XUB_ApplyProfile_for_SingleUnit(XUB_CurrentProfile, "party", i, MyUnitFrame);
            XUB_ApplyProfile_for_SingleUnit(XUB_CurrentProfile, "partypet", i, MyUnitPetFrame); -- Drome
            changesApplied = true;
        end
        XUB_PlayerPartyUnits[i] = { MyUnit, MyUnitName, MyUnitFrame, MyUnitPet, MyUnitPetName, MyUnitPetFrame }
    end

    return changesApplied;
end

function XUB_Check_for_GroupChanges()

    local myGroupType = "solo"
    local changesApplied = nil

    XUB_MakeButtons = 1;

    if ( GetNumRaidMembers() > 0 ) then
        -- player is in a raid
        myGroupType = "raid"
        -- ShowMessage("XUB-debug: going to XUB_Check_for_RaidChanges()")
        XUB_Initialize_Raidtable();
        changesApplied = XUB_Check_for_RaidChanges();
        if ( XUB_ShowPartyInRaid ) then
            local do_it_anyway = XUB_Check_for_PartyChanges();
        end
    elseif ( GetNumPartyMembers() > 0 ) then
        -- player is in a party
        myGroupType = "party"
        -- ShowMessage("XUB-debug: going to XUB_Check_for_PartyChanges()")
        changesApplied = XUB_Check_for_PartyChanges();
    else
        -- player is playing solo
        myGroupType = "solo"
        -- ShowMessage("XUB-debug: Starting apply because player is now playing solo again")
        XUB_ApplyProfile(XUB_CurrentProfile);
        return;
    end


    if ( changesApplied ) then
        ShowDebugMessage("XUB: Applied because " .. myGroupType .. " has changed")

        XUB_NextUpdate = XUB_DelayTime;      -- this defines how long all buttons are displayed after a profile change
--        XUB_NextUpdate = 2;      -- XUB-debug: For testing only
        XUB_DelayTime = XUB_DelayTime_after_automaticProfileChange;
        -- most of the time this will be '0' to prevent the display of all buttons after a party/raid change
    end

    XUB_APPLY_DELAY = -1;
    XUB_MakeButtons = 0;

end

function XUB_Old_Check_for_RaidChanges()

    local groupsize = GetNumRaidMembers();
    local MyOldGroup = XUB_PlayerRaidUnits;

    XUB_PlayerRaidUnits = {}

    if ( groupsize > 0 ) then
        -- player is in a raid
        XUB_Initialize_Raidtable();
        for i=1,groupsize do
            MyUnit = "raid" .. i;
            MyUnitName = UnitName(MyUnit)
            MyUnitFrame = XUB_RaidTable[MyUnit]
            XUB_PlayerRaidUnits[i] = { MyUnit, MyUnitName, MyUnitFrame }
        end
    end

    if ( groupsize ~= #MyOldGroup ) then      -- size of our group did change, so new buttons are needed anyway
        ShowDebugMessage("XUB: Starting apply because size of the raid has changed")
        XUB_ApplyProfile(XUB_CurrentProfile);
        return;
    end

    -- let's check if anything changed in the raid composition
    if ( MyOldGroup ~= XUB_PlayerRaidUnits ) then
        ShowMessage("XUB: Starting apply because something changed in the raid composition")
        XUB_ApplyProfile(XUB_CurrentProfile);
        return;
    end
end

function XUB_Check_for_Changes()

    if ( InCombatLockdown() ) then
        ShowDebugMessage("XUB: Changes can not be applied while in Combat, but they will be applied after combat");
        XUB_ChangesToApplyAfterCombat = XUB_CurrentProfile;
        XUB_APPLY_DELAY = -1;
        return;
    end

    if  ( XUB_ProfileChange ) then
        XUB_ProfileChange = nil;
        if ( XUB_ChangesToApplyAfterCombat ) then
            ShowDebugMessage("XUB: Combat finished - delayed changes will be applied now");
            XUB_ApplyProfile(XUB_ChangesToApplyAfterCombat);
        else
            ShowDebugMessage("XUB: Starting apply because of a profile change (user action)")
            XUB_ApplyProfile(XUB_CurrentProfile);
        end
        return;
    end

    if  ( XUB_LEARNED_SPELL_IN_TAB ) then
        -- ShowMessage("XUB-debug: Starting apply because of a spell change")
        XUB_LEARNED_SPELL_IN_TAB = nil;
        XUB_GenerateDefaultSpellsAsList();
        XUB_ApplyProfile(XUB_CurrentProfile);
        return;
    end

    if  ( XUB_RAID_ROSTER_UPDATE ) then
        XUB_RAID_ROSTER_UPDATE = nil;
        if  ( XUB_USE_NEWGROUPCHECK ) then
            -- ShowMessage("XUB-debug: Starting check because of a raid change")
            XUB_Check_for_GroupChanges();
        else
            XUB_Old_Check_for_RaidChanges();
        end
        return;
    end

    if  ( XUB_PARTY_MEMBERS_CHANGED ) then
        XUB_PARTY_MEMBERS_CHANGED = nil;
        if  ( XUB_USE_NEWGROUPCHECK ) then
            -- ShowMessage("XUB-debug: Starting check because of a party change")
            XUB_Check_for_GroupChanges();
        else
            -- ShowMessage("XUB-debug: Starting apply because of a party change")
            XUB_ApplyProfile(XUB_CurrentProfile);
        end
        return;
    end

    ShowMessage("XUB: Why the hell are we here ???")

end

--
-- Writes a message to the default chat window
--
function ShowMessage(aMessage)
    if ( aMessage == nil ) then
        DEFAULT_CHAT_FRAME:AddMessage("NIL message");
    else
        DEFAULT_CHAT_FRAME:AddMessage(aMessage);
    end
end

function XUB_ApplyProfile_for_SingleUnit(aProfileName, aUnit, aUnitNumber, aFrame)

    if ( aProfileName == "" ) then
        ShowMessage("XUB: Error: No previous profile was found.  You have to use '/XUB p <profile>' with a profile name at least once so that mod can remember what it is." );
        return;
    end

    local myCR = 0;

    local myOffsetX, myOffsetY

    local ProfileNames = {};
    ProfileNames = { strsplit("/",aProfileName) };

    for pn=1,#ProfileNames do

        for i=1,#XUB_ConfigProfiles do
            myProfileItems = XUB_ConfigProfiles[i];

            myOffsetX = myProfileItems[4];        -- myProfileItems[4]  means: X
            if ( myOffsetX == nil ) then    myOffsetX = 0;  end
            myOffsetY = myProfileItems[5];        -- myProfileItems[5]  means: Y
            if ( myOffsetY == nil ) then    myOffsetY = 0;  end

            -- If we have found the current profile
            if ( myProfileItems[1] == ProfileNames[pn] ) then                       -- myProfileItems[1]  means: PROFILE name

                -- If we have found the current Unit in the current profile
                if (myProfileItems[2] == aUnit ) then                               -- myProfileItems[2]  means: UNITBAR
                    if ( myProfileItems[3] == "CR" ) then                           -- myProfileItems[3]  means: GROUP
                        myCR = 1;
                    else
                        XUB_ApplyGroup(aUnit,aUnitNumber,myProfileItems[3],myCR,myOffsetX,-myOffsetY);
                        myCR =0;
                    end
                end

            end

        end

    end

end

--
-- Okay, this is it .. the code that adds the configured buttons to the screen.
--
function XUB_ApplyProfile(aProfileName)


    if ( aProfileName == "" ) then
        ShowMessage("XUB: Error: No previous profile was found.  You have to use '/XUB p <profile>' with a profile name at least once so that mod can remember what it is." );
        return;
    end

    if ( InCombatLockdown() ) then
        XUB_ChangesToApplyAfterCombat = aProfileName;
        ShowMessage("XUB: Changes can not be applied while in Combat, but they will be applied after combat");
        return;
    end

    XUB_ChangesToApplyAfterCombat = nil;

    XUB_MakeButtons = 1;

    XUB_RemoveButtons();
--    ShowMessage("XUB-debug: Buttons removed")

    XUB_CurrentProfile = aProfileName;

    --XUB_ConfigButtons = {}
    --XUB_ConfigGroup = {}
    --XUB_ConfigProfile = {}

    local myCR = 0;

    local PROFILE = 1;
    local UNITBAR = 2;
    local GROUP = 3;
    local X = 4;
    local Y = 5;


    XUB_UPDATEUNITS = {};   -- Clear the frames that require updating
    XUB_ButtonQueue = {};    -- Clear the list buttons created

    XUB_Buttons["float"] = { x = XUB_XOFFSET , y = XUB_YOFFSET };

    local myOffsetX, myOffsetY
    local ProfileNames = {};
    ProfileNames = { strsplit("/",aProfileName) };

    local inRaid = nil;
    local inGroup = nil;
    if ( GetNumRaidMembers() > 0 ) then
        inRaid = 1;
    elseif ( GetNumPartyMembers() > 0 ) then
        inGroup = 1;
    end

    -- ShowMessage("XUB-debug: inRaid: " .. CCC(inRaid))
    -- ShowMessage("XUB-debug: GetNumRaidMembers(): " .. CCC(GetNumRaidMembers()))
    -- ShowMessage("XUB-debug: GetNumPartyMembers(): " .. CCC(GetNumPartyMembers()))

    for pn=1,#ProfileNames do

        for i=1,#XUB_ConfigProfiles do
            myProfileItems = XUB_ConfigProfiles[i];

            --ShowMessage("Profile Items: 1: Profile   2: Unit   3: Group   4: X   5: Y" );
            --ShowMessage("Profile Items: " .. myProfileItems[1] .. "   " .. myProfileItems[2] .. "   " .. myProfileItems[3] .. "   "  .. myProfileItems[4] .. " 5:"  .. myProfileItems[5] );

            myOffsetX = myProfileItems[X];
            myOffsetY = myProfileItems[Y];

            if ( myOffsetX == nil ) then
                myOffsetX = 0;
            end
            if ( myOffsetY == nil ) then
                myOffsetY = 0;
            end

            if ( ProfileNames[pn] == myProfileItems[PROFILE] ) then

                if ( myProfileItems[GROUP] == "CR" ) then
                    myCR = 1;
                elseif ( myProfileItems[UNITBAR] == "party" ) then
                    if ( inGroup ) or ( XUB_ShowPartyInRaid ) then
                        for j=1,GetNumPartyMembers() do
                            XUB_ApplyGroup("party",j,myProfileItems[GROUP],myCR,myOffsetX,-myOffsetY);
                        end
                        myCR = 0;
                    end
                elseif ( myProfileItems[UNITBAR] == "partypet" ) then
                    if ( inGroup ) or ( XUB_ShowPartyInRaid ) then
                        for j=1,GetNumPartyMembers() do
                            XUB_ApplyGroup("partypet",j,myProfileItems[GROUP],myCR,myOffsetX,-myOffsetY);
                        end
                        myCR = 0;
                    end
                elseif ( myProfileItems[UNITBAR] == "raid" ) then
                    if ( inRaid ) then
                        for i=1,GetNumRaidMembers() do
--                            ShowMessage("XUB-debug:starting to apply group '" .. myProfileItems[GROUP] .. "' for raid" .. i)
                            XUB_ApplyGroup("raid",i,myProfileItems[GROUP],myCR,myOffsetX,-myOffsetY);
                        end
                        myCR = 0;
                    end
                elseif ( myProfileItems[UNITBAR] == "raidpet" ) then
                    if ( inRaid ) then
                        --for i=1,40 do
                        --    XUB_ApplyGroup("raidpet",i,myProfileItems[GROUP],myCR,myOffsetX,-myOffsetY);
                        --end
                        myCR = 0;
                    end
                else
                    XUB_ApplyGroup(myProfileItems[UNITBAR],0,myProfileItems[GROUP],myCR,myOffsetX,-myOffsetY);
                    myCR = 0;
                end
            end

        end

    end

    XUB_MakeButtons = 0;
    XUB_APPLY_DELAY = -1;

    XUB_NextUpdate = XUB_DelayTime;      -- this defines how long all buttons are displayed after a profile change
    XUB_DelayTime = XUB_DelayTime_after_automaticProfileChange;

    if ( XUB_Buttons["float"].x == XUB_XOFFSET ) and ( XUB_Buttons["float"].y == XUB_YOFFSET ) then
        getglobal("XUB_FloatingFrame"):Hide();
    else
        getglobal("XUB_FloatingFrame"):Show();
    end

    if  ( XUB_USE_NEWGROUPCHECK ) then
      XUB_Fill_GroupUnitLists();
    end

--    collectgarbage("collect");
    ShowMessage("XUB_CurrentProfile: "..XUB_CurrentProfile);

end

function XUB_Get_UnitProperties(aUnit,aUnitNumber)

    local myFrame = nil;
    local myWidth = 20;
    local myAlwaysGenerate = 1;
    local x1,x2,group,slot;

    if ( aUnit == "party" ) or ( aUnit == "partypet" ) or ( aUnit == "raid" ) or ( aUnit == "raidpet" ) then
        if ( aUnitNumber == 0 ) then
            ShowMessage("Party\Raid members and their pets need a number to identify." );
            return myFrame, myWidth, myAlwaysGenerate;
        end
        x1 = aUnitNumber;
        if ( aUnitNumber < 10 ) then
            x2 = "0" .. aUnitNumber;
        else
            x2 = aUnitNumber;
        end

        slot  = ( aUnitNumber - 1 ) % 5 + 1;
        group = ( aUnitNumber - slot ) / 5 + 1;

        myAlwaysGenerate = 0;
    end

    if ( aUnit == "player" ) then
        myFrame = XUB_UF_Player;
        myWidth = XUB_UF_WIDTH_Player;
    elseif ( aUnit == "playerpet" ) then
        myFrame = XUB_UF_PlayerPet;
        myWidth = XUB_UF_WIDTH_PlayerPet;
    elseif ( aUnit == "target" ) then
        myFrame = XUB_UF_Target;
        myWidth = XUB_UF_WIDTH_Target;
    elseif ( aUnit == "focus" ) then
        myFrame = XUB_UF_Focus;
        myWidth = XUB_UF_WIDTH_Focus;
    elseif ( aUnit == "float" ) then
        myFrame = "XUB_FloatingFrame";
        myWidth = XUB_UF_WIDTH_Float;
    elseif ( aUnit == XUB_UF_CUSTOMNAME1 ) then
        myFrame = XUB_UF_CUSTOMFRAME1;
        myWidth = XUB_UF_CUSTOMWIDTH1;
    elseif ( aUnit == XUB_UF_CUSTOMNAME2 ) then
        myFrame = XUB_UF_CUSTOMFRAME2;
        myWidth = XUB_UF_CUSTOMWIDTH2;
    elseif ( aUnit == XUB_UF_CUSTOMNAME3 ) then
        myFrame = XUB_UF_CUSTOMFRAME3;
        myWidth = XUB_UF_CUSTOMWIDTH3;
    elseif ( aUnit == XUB_UF_CUSTOMNAME4 ) then
        myFrame = XUB_UF_CUSTOMFRAME4;
        myWidth = XUB_UF_CUSTOMWIDTH4;
    elseif ( aUnit == XUB_UF_CUSTOMNAME5 ) then
        myFrame = XUB_UF_CUSTOMFRAME5;
        myWidth = XUB_UF_CUSTOMWIDTH5;
    elseif ( aUnit == "party" ) then
        myFrame = XUB_UF_Party:gsub("!!",x2):gsub("!",x1):gsub("#",slot):gsub("@",group);
        myWidth = XUB_UF_WIDTH_Party;
    elseif ( aUnit == "partypet" ) then
        myFrame = XUB_UF_PartyPet:gsub("!!",x2):gsub("!",x1):gsub("#",slot):gsub("@",group);
        myWidth = XUB_UF_WIDTH_PartyPet;
    elseif ( aUnit == "raid" ) then
        if ( XUB_RaidTable["raid" .. aUnitNumber] ) then
            myFrame = XUB_RaidTable["raid" .. aUnitNumber];
        end
        myWidth = XUB_UF_WIDTH_RaidMember;
    elseif ( aUnit == "raidpet" ) then
        myFrame = XUB_UF_RaidPet:gsub("!!",x2):gsub("!",x1):gsub("#",slot):gsub("@",group);
        myWidth = XUB_UF_WIDTH_RaidPet;
    else
        ShowMessage("XUB: Unknown unit '" .. aUnit .. "'." );
    end

--    ShowMessage("XUB-debug: myFrame " .. CCC(myFrame));
--    ShowMessage("XUB-debug: myWidth " .. CCC(myWidth));
--    ShowMessage("XUB-debug: myAlwaysGenerate " .. CCC(myAlwaysGenerate));
    return myFrame, myWidth, myAlwaysGenerate;

end

function XUB_ApplyGroup(aUnit,aUnitNumber,aGroupName,aCR,aXOffset,aYOffset)

    local myFrame, myWidth, myAlwaysGenerate

    myFrame, myWidth, myAlwaysGenerate = XUB_Get_UnitProperties(aUnit, aUnitNumber)

    if ( myFrame == nil) then
        --ShowMessage("XUB-debug: no frame found for unit " .. CCC(aUnit .. aUnitNumber));
        return;
    end

    if ( string.find(myFrame,"/") ) then
        --ShowMessage("XUB-debug: more then one frame found for unit " .. CCC(aUnit) .. ". Frames: " .. CCC(myFrame));
    end

    local GROUP = 1;
    local BUTTON = 2;
    local DESTUNIT = 3;
    local EXCLUDEUNIT = 4;

    local myFrames = {};
    local myDestinationUnit = 0;
    local myExcludeUnit;

    local myFoundFrame = 0;
    local myDestinationUnit_is_in_XUB_UPDATEUNITS = 0;
    local myFound = 0;


    if ( aUnitNumber ~= 0 ) then
        aUnit = aUnit .. aUnitNumber;
    end
    local myFirst = 1;
    if ( XUB_Buttons[aUnit] == nil ) then                                   -- if there have been no buttons made for this unit yet, then
        XUB_Buttons[aUnit] = { x = XUB_XOFFSET , y = XUB_YOFFSET };         --    initialise the first button with x = XUB_XOFFSET , y = XUB_YOFFSET
        myFirst = 0;
    end



    for j=1,#XUB_ConfigGroups do
        myGroupItems = XUB_ConfigGroups[j];

        if ( myGroupItems[GROUP] == aGroupName ) then

            myExcludeUnit = myGroupItems[EXCLUDEUNIT];
            if ( myExcludeUnit == nil ) then
                myExcludeUnit = "";
            end

            if ( aUnit == "float" ) and ( myGroupItems[DESTUNIT] == "*" ) then
                ShowMessage("XUB: Error: You must specify a destination unit other than '*' when assigning to the float bar.");
            end

            if ( myGroupItems[DESTUNIT] == "*" ) then
                myDestinationUnit = aUnit;
            elseif ( myGroupItems[DESTUNIT] == "party" ) then
                if ( string.sub(aUnit,1,5) == "party" ) then
                    myDestinationUnit = aUnit;
                else
                    ShowMessage("XUB: Warning: Trying to attach a party button to a unit that is not party.");
                end
            elseif ( myGroupItems[DESTUNIT] == "raid" ) then
                if ( string.sub(aUnit,1,4) == "raid" ) then
                    myDestinationUnit = aUnit;
                else
                    ShowMessage("XUB: Warning: Trying to attach a raid button to a unit that is not raid.");
                end
            else
                myDestinationUnit = myGroupItems[DESTUNIT];
            end

            if ( myDestinationUnit ~= 0 ) then

                myFoundFrame = 0;

                myFrames = {};
                myFrames = { strsplit("/",myFrame) };

               -- ShowMessage("myAlwaysGenerate " .. myAlwaysGenerate );
                for di=#myFrames,1,-1 do            -- go through all possible frames for this unit
                    -- ShowMessage("myFrames[di] " .. CCC(myFrames[di]) );
                    if ( getglobal(myFrames[di]) ~= nil ) then
                        -- if ( getglobal(myFrames[di]):IsVisible() ) then
                        --     ShowMessage("Visible: Yes" );
                        -- else
                        --     ShowMessage("Visible: No" );
                        -- end
                        if ( getglobal(myFrames[di]):IsVisible() ) or ( myAlwaysGenerate == 1) then
                            --ShowMessage("XUB-debug: " .. CCC(myFrames[di]) .. CCC(di) .. CCC(aUnit) .. CCC(aUnitNumber) .. CCC(myGroupItems[BUTTON]) .. CCC(myDestinationUnit) .. CCC(aCR) .. CCC(myFirst) .. CCC(aXOffset) .. CCC(aYOffset) .. CCC(myExcludeUnit) .. CCC(myWidth));
                            XUB_ApplyGroupButton(myFrames[di],di,aUnit,aUnitNumber,myGroupItems[BUTTON],myDestinationUnit,aCR,myFirst,aXOffset,aYOffset,myExcludeUnit,myWidth);
                            myFoundFrame = 1;
                        end
                    else
                        ShowMessage("XUB: Unable to find " .. CCC(myFrames[di]) .. ". No buttons could be attached to this frame." );
                    end
                end

                if ( myFoundFrame == 0 ) then
                    ShowDebugMessage("XUB: Warning: no valid frame found for unit .. " .. CCC(aUnit) .. ". Frames: " .. CCC(myFrame) );
                    return;
                else
                    if string.find( string.upper(myDestinationUnit), "-TARGET" ) then
                        if aUnit == "float" then
                            myDestinationUnit = "target"
                        else
                            myDestinationUnit = aUnit
                        end
                    end

                    myDestinationUnit_is_in_XUB_UPDATEUNITS = 0;
                    for counter=1,#XUB_UPDATEUNITS do
                        if ( XUB_UPDATEUNITS[counter] == myDestinationUnit ) then
                            myDestinationUnit_is_in_XUB_UPDATEUNITS = 1;
                            break;
                        end
                    end

                    if ( myDestinationUnit_is_in_XUB_UPDATEUNITS == 0 ) then
                        table.insert( XUB_UPDATEUNITS , myDestinationUnit );
                    end;

                end

                aXOffset = 0;
                aYOffset = 0;

                myFound = 1;
                myFirst = 0;
                aCR = 0;
            end


        end
    end

    if myFound == 0 then
        ShowMessage("XUB Error: Could not find a GROUP definition for group: '" .. aGroupName .."'");
    end

end

function XUB_ApplyGroupButton(aFrame,aFrameNo,aOnUnit,aUnitNumber,aButton,aDestUnit,aCR,aFirst,aXOffset,aYOffset,aExcludeUnits,aWidth)

--[[
    ShowMessage("at XUB_ApplyGroupButton:");
    ShowMessage("aFrame: " .. CCC(aFrame) );
    ShowMessage("aFrameNo: " .. CCC(aFrameNo) );
    ShowMessage("aOnUnit: " .. CCC(aOnUnit) );
    ShowMessage("aUnitNumber: " .. CCC(aUnitNumber) );
    ShowMessage("aButton: " .. CCC(aButton) );
    ShowMessage("  ");
]]

    local l_BUTTON    = 1;
    local l_TYPE      = 2;
    local l_SPELLNAME = 3;
    local l_RANK      = 4;

    local l_THRESHOLD = 5;   -- Heal type
    local l_DEBUFF    = 5;   -- Debuff type
    local l_BUFF      = 5;   -- Buff type
    local l_MACRO     = 4;   -- Macro text

    local totalButtons = #XUB_DefaultButtonsArray + #XUB_ConfigButtons;
    local myToolTip = "";
    local mySpell, myRank, myThreshold, myExtraType,myExtra
    local myEndblinktime

    for k=1,totalButtons do

        if ( k <= #XUB_DefaultButtons ) then
            myButtonItems = XUB_DefaultButtonsArray[k];
        else
            myButtonItems = XUB_ConfigButtons[k - #XUB_DefaultButtonsArray];
        end

        myToolTip = "";

        if ( myButtonItems[l_BUTTON] == aButton ) then

            mySpell = myButtonItems[l_SPELLNAME];
            myRank = myButtonItems[l_RANK];

            myThreshold = 0;
            myExtraType = nil;
            myExtra = nil;

            if ( myButtonItems[l_TYPE] == "spell" ) then

                -- Nothing to do

            elseif ( myButtonItems[l_TYPE] == "always" ) then

                myExtraType = "ALWAYS";
                myToolTip = "\nShow always, do not hide.";

            elseif ( myButtonItems[l_TYPE] == "spellblink" ) then

                myExtraType = "SPELLBLINK";
                myToolTip = "\nStarts blinking if the button is not a buff or debuff on the specified unit.";

            elseif ( myButtonItems[l_TYPE] == "health" ) then

                myThreshold = tonumber(myButtonItems[l_THRESHOLD]);
                myExtraType = "HEALTH";
                myToolTip = "\nVisible when Unit Damage >= " .. myThreshold;

            elseif ( myButtonItems[l_TYPE] == "healthblink" ) then

                myThreshold = tonumber(myButtonItems[l_THRESHOLD]);
                myExtraType = "HEALTHBLINK";
                myToolTip = "\nBlinks when Unit Damage >= " .. myThreshold;

            elseif ( myButtonItems[l_TYPE] == "debuff" ) then

                myExtraType = "DEBUFF";
                myExtra = myButtonItems[l_DEBUFF];

                myToolTip = "\nShown when unit has these debuffs: " .. myExtra;

            elseif ( myButtonItems[l_TYPE] == "debuffblink" ) then

                myExtraType = "DEBUFFBLINK";
                myExtra = myButtonItems[l_DEBUFF];

                myToolTip = "\nStarts blinking when unit has these debuffs: " .. myExtra;

            elseif ( string.find(myButtonItems[l_TYPE],"buffblink" ) ) then

--                myExtraType = "BUFFBLINK";
                myExtraType = string.upper(myButtonItems[l_TYPE]);
                myExtra = myButtonItems[l_BUFF];

                myToolTip = "\nStarts blinking if not buffed and not affected with: " .. myExtra;

                if string.len(myExtraType) > string.len("BUFFBLINK") then
                    -- get the attached Endblinktime
                    myEndblinktime = string.sub(myExtraType,string.len("BUFFBLINK")+1);
                    if tonumber(myEndblinktime) then
                        myToolTip = myToolTip .. "\nStarts also blinking in the last " .. string.format("%d",myEndblinktime) .. "seconds of the buff.";
                    end
                end

            elseif ( string.find(myButtonItems[l_TYPE],"buff" ) ) then

--                myExtraType = "BUFF";
                myExtraType = string.upper(myButtonItems[l_TYPE]);
                myExtra = myButtonItems[l_BUFF];

                myToolTip = "\nNot shown if unit is also buffed or affected with: " .. myExtra;

                if string.len(myExtraType) > string.len("BUFF") then
                    -- get the attached Endblinktime
                    myEndblinktime = string.sub(myExtraType,string.len("BUFF")+1);
                    if tonumber(myEndblinktime) then
                        myToolTip = myToolTip .. "\nStarts also blinking in the last " .. string.format("%d",myEndblinktime) .. "seconds of the buff.";
                    end
                end

            elseif ( myButtonItems[l_TYPE] == "macro" ) then

                myThreshold = tonumber(myButtonItems[3]);

                myExtraType = "MACRO";
                myExtra = myButtonItems[l_MACRO]:gsub("#",aUnitNumber);

                myToolTip = "Macro: \n\n" .. myExtra;

            elseif ( myButtonItems[l_TYPE] == "use" ) then

                myExtraType = "USE";
                mySpell = myButtonItems[l_SPELLNAME]
                if ( myButtonItems[4] ~= nil ) then
                    myExtra = myButtonItems[4];
                    if ( not string.find(myExtra,"!") ) then
                        myToolTip = "Use item '" .. mySpell .. "' on " .. aDestUnit .. "\n\nDo not show if buffed with '" .. myExtra .. "'";
                    else
                        myToolTip = "Use item '" .. mySpell .. "' on " .. aDestUnit .. "\n\nOnly show if debuffed with '" .. string.sub(myExtra,2) .. "'";
                    end
                else
                    myExtra = "";
                    myToolTip = "Use item '" .. mySpell .. "' on " .. aDestUnit;
                end

                myRank = "";



            end

            --ShowMessage( "Making button mySpell '" .. mySpell .. "' myRank '" .. myRank .. "' on " .. aOnUnit .. " for " .. aDestUnit .. " type '" .. CCC(myButtonItems[l_TYPE]) .. "'" );

            if ( aCR == 1 ) then
                if ( XUB_Buttons[aOnUnit] == nil ) then
                    XUB_Buttons[aOnUnit] = { x = 0 , y = 0 };
                else
                    XUB_Buttons[aOnUnit].x = XUB_XOFFSET;
                    XUB_Buttons[aOnUnit].y = XUB_Buttons[aOnUnit].y - XUB_ButtonSize - XUB_BUTTON_SPACING - 1;
                end
                aFirst = 0;
            end

            XUB_Buttons[aOnUnit].x = XUB_Buttons[aOnUnit].x + aXOffset + ( aFirst * XUB_GROUPSPACING ) + XUB_BUTTON_SPACING;
            XUB_Buttons[aOnUnit].y = XUB_Buttons[aOnUnit].y + aYOffset;

            XUB_MakeButton(aFrame,aFrameNo,aOnUnit,aDestUnit,mySpell,myRank,myThreshold,myExtraType,myExtra,myToolTip,aExcludeUnits,aWidth);

            return;

        end
    end

end

--
-- Makes a button on a unit frame.  The unit who receives the spell is identified by the
-- DesinationUnit.  The ManaCost is used by the mod to determine which spells are available
-- given an amount of available mana (rage or energy) and the Optional Seperators puts in
-- one or more 20 pixel wide seperators between this button and the previous one

function XUB_MakeButton(aFrame,aFrameNo,aUnit,aDestinationUnit,aSpellName,aRank,aThreshold,aExtraType,aExtra,aToolTip,aExcludeUnits,aWidth)

                local debug_save = XUB_DEBUG
                if  (aFrameNo ~= 1) or (aUnit == nil) or (aUnit == "") then
                    XUB_DEBUG = 1
                    ShowDebugMessage("We are here because aUnit is NOK or aFrameNo~=1.");
                end
                if  (aFrameNo ~= 1) or (aUnit == nil) or (aUnit == "") then
                    ShowMessage("XUB-Error: aUnit is NOK or aFrameNo~=1.");
                end
                ShowDebugMessage("aFrame: " .. CCC(aFrame) );
                ShowDebugMessage("aFrameNo: " .. CCC(aFrameNo) );
                ShowDebugMessage("aUnit: " .. CCC(aUnit) );
                ShowDebugMessage("aDestinationUnit: " .. CCC(aDestinationUnit) );
                ShowDebugMessage("aSpellName: " .. CCC(aSpellName) );
                ShowDebugMessage("aRank: " .. CCC(aRank) );
                ShowDebugMessage("aThreshold: " .. CCC(aThreshold) );
                ShowDebugMessage("aExtra: " .. CCC(aExtra) );
                ShowDebugMessage("aToolTip: " .. CCC(aToolTip) );
                ShowDebugMessage("aExcludeUnits: " .. CCC(aExcludeUnits) );
                ShowDebugMessage("aWidth: " .. CCC(aWidth) );
                ShowDebugMessage("-------------------------------------------");
                ShowDebugMessage("    ");
                XUB_DEBUG=debug_save

    local l_mainDestinationUnit = aDestinationUnit
    if string.find( string.upper(l_mainDestinationUnit), "-TARGET" ) then
        aDestinationUnit = string.upper(aDestinationUnit)
        if aUnit == "float" then
            l_mainDestinationUnit = "target"
        else
            l_mainDestinationUnit = aUnit
        end
    end

    -- Increment the number used to uniquely identify the buttons (so we can do a getglobal later to find the frame/button).
    if XUB_Units[l_mainDestinationUnit] then
        XUB_Units[l_mainDestinationUnit] = XUB_Units[l_mainDestinationUnit] + 1
    else
        ShowMessage("l_mainDestinationUnit: " .. l_mainDestinationUnit);
        ShowMessage("XUB_Units[l_mainDestinationUnit]: " .. CCC(XUB_Units[l_mainDestinationUnit]));
        return;
    end

    local myButtonName = XUB_GenerateButtonName(l_mainDestinationUnit,XUB_Units[l_mainDestinationUnit]);
    --ShowMessage( "CREATING '" .. XUB_GenerateButtonName(l_mainDestinationUnit,XUB_Units[l_mainDestinationUnit]) .. "'");


    if ( XUB_DEBUG > 0 ) then
        local myMessage = "Frame: '" .. aFrame .. "'                                 ";
        myMessage = string.sub(myMessage,1,40);
        myMessage = myMessage .. "  Unit where the Button/Frame is attached to (aUnit): '" .. aUnit .."'";
        ShowMessage( myMessage );
        myMessage = "Destination Unit: '" .. l_mainDestinationUnit .. "'                              ";
        if string.find( aDestinationUnit, "-TARGET" ) then
            myMessage = "main DestinationUnit for Multi-Target button '" .. l_mainDestinationUnit .. "'                              ";
        end
        myMessage = string.sub(myMessage,1,40);
        myMessage = myMessage .. "    Spell Name: '" .. aSpellName .. "'";
        ShowMessage( myMessage );
        ShowMessage( "    " );
    end

    local myButton = getglobal(myButtonName);
    local myTexture, SpellID;

    if ( myButton == nil ) then
        myButton = CreateFrame("Button", myButtonName, UIParent,  "XUB_ActionButtonTemplate");
        --ShowMessage("newly created button: myButtonName: '" .. CCC(myButtonName) .. "'");

        local new_cooldown = getglobal(myButton:GetName()..'Cooldown');
        myButton.CooldownFrame = new_cooldown;

        myButton:SetWidth(XUB_ButtonSize);
        XUB_Initialize_CountdownLayer_and_Font(myButton);
    else
        --ShowMessage("reused button: myButtonName: '" .. CCC(myButtonName) .. "'");
    end

    myButton:SetFrameStrata(XUB_FRAME_STRATA);
    myButton:SetButtonState(XUB_BUTTON_STRATA);


    local myUseButtonArray = {}
    table.insert( myUseButtonArray , "LeftButtonUp" );

    if XUB_UseRightButton then
      table.insert( myUseButtonArray , "RightButtonUp" );
--      myUseButtonString = myUseButtonString .. ", \"RightButtonUp\""
      XUB_UseRightButton = "RightButtonUp"
    end
    if XUB_UseMiddleButton then
      table.insert( myUseButtonArray , "MiddleButtonUp" );
--      myUseButtonString = myUseButtonString .. ", \"MiddleButtonUp\""
      XUB_UseMiddleButton = "MiddleButtonUp"
    end
    if XUB_UseButton4 then
      table.insert( myUseButtonArray , "Button4Up" );
--      myUseButtonString = myUseButtonString .. ", \"Button4Up\""
      XUB_UseButton4 = "Button4Up"
    end
    if XUB_UseButton5 then
      table.insert( myUseButtonArray , "Button5Up" );
--      myUseButtonString = myUseButtonString .. ", \"Button5Up\""
      XUB_UseButton5 = "Button5Up"
    end

--    myButton:RegisterForClicks("AnyUp");
--    myButton:RegisterForClicks(myUseButtonArray);
--    myButton:RegisterForClicks(myUseButtonString);
--      myButton:RegisterForClicks("LeftButtonUp", "RightButtonUp", "MiddleButtonUp", "Button4Up", "Button5Up")
--     myButton:RegisterForClicks("LeftButtonUp", XUB_UseRightButton, XUB_UseMiddleButton, XUB_UseButton4, XUB_UseButton5);
      myButton:RegisterForClicks(myUseButtonArray[1], myUseButtonArray[2], myUseButtonArray[3], myUseButtonArray[4], myUseButtonArray[5]);

    myButton.NoIcon = 0;

    XUB_ButtonQueue[#XUB_ButtonQueue+1] = myButton;

    if ( aExtraType == "MACRO" ) then
        -- Required call
        GetNumMacroIcons();
        -- aThreshold holds the id for the macro.
        myTexture = GetMacroIconInfo(aThreshold);
        if ( myTexture == nil ) then
            myTexture = "Interface\Icons\INV_Misc_QuestionMark";
        elseif ( myTexture == "" ) then
            myTexture = "Interface\Icons\INV_Misc_QuestionMark";
        end
        myButton:SetAttribute('type','macro');
        myButton:SetAttribute('*macrotext*', aExtra );  --TAYEDAEN: unsure if 'macrotext' alone would be enough here
    else
        if ( aExtraType == "USE" ) then
            local USEitemName, USEitemLink, USEitemRarity, USEitemLevel, USEitemMinLevel, USEitemType, USEitemSubType, USEitemStackCount, USEitemEquipLoc
            USEitemName, USEitemLink, USEitemRarity, USEitemLevel, USEitemMinLevel, USEitemType, USEitemSubType, USEitemStackCount, USEitemEquipLoc, myTexture = GetItemInfo(aSpellName)
            if ( myTexture == nil ) or ( myTexture == "" ) then
                myTexture = "Interface\Icons\INV_Misc_QuestionMark";
                myButton.NoIcon = 1;
            end

            myButton:SetAttribute('type','item');
            myButton:SetAttribute('*item*', aSpellName );  --TAYEDAEN: unsure if 'item' alone would be enough here

            SpellID = 0;
            myButton.UseItemName = aSpellName;
            myButton.UseHideItems = aExtra;
        else                    -- some kind of spell button
--            ShowMessage("aSpellName: " .. aSpellName );
            local l_MaxSpellRankString = ""
            myTexture = ""
            if ( aRank ) then
                if ( aRank == "" ) then
                    if ( aSpellName:find("@)") ~= nil ) then
--                        ShowMessage("XUB-debug: Spell with included '@' found. SpellName: "..aSpellName);
                        myButton.FullSpellName = aSpellName .. "()";
                    else
--                        ShowMessage("XUB-debug: Spell without Rank found. Spellname: "..aSpellName);
                        myButton.FullSpellName = aSpellName .. "()";
                    end
                    myButton.Rank = -1;
                elseif string.find( string.upper(aRank), "-RANKED" ) then
--                    ShowMessage("XUB-debug:  MultiRanked Spell found. Spellname: "..aSpellName);

                    --Find highest Rank (l_MaxSpellRank)
                    local l_i =1;
                    local l_foundID
                    local l_SpellName,l_Rank = GetSpellName(l_i,SpellBookFrame.bookType )
                    while ( l_SpellName ~= nil ) do
                        if ( l_SpellName == aSpellName ) then
                            l_MaxSpellRankString = l_Rank;
                            l_foundID = l_i
                        end
                        l_i=l_i + 1;
                        l_SpellName,l_Rank = GetSpellName(l_i,SpellBookFrame.bookType );
                    end

                    myButton.Rank = aRank
                    myButton.FullSpellName = aSpellName .. "()";
                    SpellID = l_foundID
                    --ShowMessage("XUB-debug:  SpellID: "..CCC(SpellID).."    aRank: "..CCC(aRank).."    l_foundID: "..CCC(l_foundID).."    l_i: "..CCC(l_i));
                    myTexture = GetSpellTexture(SpellID,SpellBookFrame.bookType)
                else
--                    ShowMessage("XUB-debug:  Ranked Spell found. Spellname: "..aSpellName.."     Rank: "..aRank);
                    myButton.Rank = aRank
                    myButton.FullSpellName = aSpellName .. "(" .. aRank .. ")";
                end
            else
                ShowMessage("XUB: Spell found where rank = NIL!!! '" .. aSpellName .."'");
                if ( aSpellName:find("@)") ~= nil ) then
                    myButton.FullSpellName = aSpellName .. "()";
                    ShowMessage("been 1");
                else
                    myButton.FullSpellName = aSpellName
                    ShowMessage("been 2");
                end
                myButton.Rank = -1;
            end
            if ( myTexture == "" ) then
                myTexture, SpellID = XUB_GetSpellTextureAndID(aSpellName, aRank)
            end

            if ( myTexture == "" ) then
                ShowMessage( "XUB: Error: '" .. aSpellName .. "' on frame '" .. aUnit .. "' for  DestinationUnit '" .. aDestinationUnit .. "' is not valid for your class.  Ignoring specification." );
                XUB_Units[l_mainDestinationUnit] = XUB_Units[l_mainDestinationUnit] - 1;
                return;
            end

            myButton:SetAttribute("type", "spell")

            myButton:SetAttribute("*spell2", myButton.FullSpellName )
            myButton:SetAttribute("*spell3", myButton.FullSpellName )
            myButton:SetAttribute("shift-spell*", myButton.FullSpellName )
            myButton:SetAttribute("alt-spell*", myButton.FullSpellName )
            myButton:SetAttribute("*spell*", myButton.FullSpellName )
            myButton.Multirank  = ""
            if ( aRank ) and ( string.find( string.upper(aRank), "-RANKED" ) ) then

                local l_MaxSpellRank = 1
                local myRanknumberPosition
                _, myRanknumberPosition = string.find(l_MaxSpellRankString, RANK .. " ");
                l_MaxSpellRankString = string.sub(l_MaxSpellRankString, myRanknumberPosition+1);
                if ( tonumber(l_MaxSpellRankString) ) then
                    l_MaxSpellRank = tonumber(l_MaxSpellRankString);
                end
                l_MiddleSpellRank = math.ceil(0.65 * l_MaxSpellRank)
                if ( l_MiddleSpellRank < (l_MaxSpellRank -2) ) then
                    l_MiddleSpellRank = l_MaxSpellRank -2;
                end

                if string.upper(aRank) == "MB-RANKED" then       --different mouseclicks cast different ranks
                    myButton:SetAttribute("*spell2", aSpellName .. "(" .. RANK .. " 1)" )
                    myButton:SetAttribute("*spell3", aSpellName .. "(" .. RANK .. " " .. l_MiddleSpellRank .. ")" )
                    myButton:SetAttribute("*spell*", myButton.FullSpellName )
                    myButton.Multirank  = "MB-RANKED"
                elseif string.upper(aRank) == "KB-RANKED" then   --different keyboard modifier cast different ranks
                    myButton:SetAttribute("shift-spell*", aSpellName .. "(" .. RANK .. " 1)" )
                    myButton:SetAttribute("alt-spell*", aSpellName .. "(" .. RANK .. " " .. l_MiddleSpellRank .. ")" )
                    myButton:SetAttribute("*spell*", myButton.FullSpellName )
                    myButton.Multirank  = "KB-RANKED"
                end
            end
            myButton:SetAttribute("*spell*", myButton.FullSpellName )
        end

        if aDestinationUnit == "MB-TARGET" then         --different mouseclicks cast to different targets
            myButton:SetAttribute("*unit2", "player")
            myButton:SetAttribute("*unit3", "target")
            myButton:SetAttribute("*unit4", "focus")
            myButton:SetAttribute("*unit*", l_mainDestinationUnit)
            myButton.Multitarget = "MB-TARGET"
        elseif aDestinationUnit == "KB-TARGET" then     --different keyboard modifier cast to different targets
            myButton:SetAttribute("alt-unit*", "player")
            myButton:SetAttribute("shift-unit*", "target")
            myButton:SetAttribute("ctrl-unit*", "focus")
            myButton.Multitarget = "KB-TARGET"
        else
            myButton:SetAttribute("*unit2", l_mainDestinationUnit)
            myButton:SetAttribute("*unit3", l_mainDestinationUnit)
            myButton:SetAttribute("*unit4", l_mainDestinationUnit)
            myButton:SetAttribute("alt-unit*", l_mainDestinationUnit)
            myButton:SetAttribute("shift-unit*", l_mainDestinationUnit)
            myButton:SetAttribute("ctrl-unit*", l_mainDestinationUnit)
            myButton:SetAttribute("*unit*", l_mainDestinationUnit)
            myButton.Multitarget = ""
        end
    end    -- if ( aExtraType == "USE" ) then Else (some kind of spellbutton) end

    myButton:SetNormalTexture(myTexture)
    myButton:SetHighlightTexture(myTexture)
    myButton:SetWidth(XUB_ButtonSize);
    myButton:SetHeight(XUB_ButtonSize);
    myButton:SetScale(tonumber(aWidth) / XUB_ButtonSize);

    myButton:Enable();
    myButton:Show();
    myButton:SetAlpha(1);

    --ShowMessage( "Making button '" .. aSpellName .. aRank .. "' on " .. aUnit .. " for " .. aDestinationUnit .. " type '" .. CCC(aExtraType) .. "'" );

    -- Set some attributes on the button so when can reference them later
    myButton.isActive        = 1;                       -- Set to 0 if it is removed from screen during button reload
    myButton.Spell           = aSpellName;              -- Name of the spell on the button
    myButton.SpellID         = SpellID;                 -- ID Number of the spell
    myButton.Bar             = aUnit;                   -- The bar the button is on.  When the bar isn't selected; the button should turn off
    myButton.DestinationUnit = l_mainDestinationUnit;   -- Name of the unit receiving the spell
    myButton.ToolTip         = aToolTip;                -- Text for the tooltip
    myButton.ExcludeUnits    = aExcludeUnits;           -- Units where a buttons should auto-hide.
    myButton.AttachedFrame   = aFrame;                  -- Attached Frame
    myButton.State           = 0;
    myButton.isSTATE_ENABLED    = nil;
    myButton.isSTATE_HEALTHOFF  = nil;
    myButton.isSTATE_BUFFED     = nil;
    myButton.isSTATE_DIMMED     = nil;
    myButton.isSTATE_COOLDOWN   = nil;
    myButton.isSTATE_NO_ITEMS   = nil;
    myButton.isSTATE_OUTOFMANA  = nil;
    myButton.isSTATE_OUTOFRANGE = nil;
    myButton.isSTATE_INVALID    = nil;
    myButton.ExtraType       = aExtraType;              -- added for Gametooltip
    myButton.Blink           = 0;                       -- If "1" causes button to blink when unbuffed or debuffed

    if ( aExtraType == "MACRO" ) then
        myButton.isMacro = 1;
        myButton.Threshold = 0;
        myButton.SpellID = 0;
    else
        myButton.isMacro = 0;
        myButton.Threshold = aThreshold;
    end

   if ( aExtraType == "USE" ) then
        myButton.isUse = 1;
    else
        myButton.isUse = 0;
    end

    if ( aExtraType == "SPELLBLINK" ) then
        myButton.Blink = 1;
    end

    if ( aExtraType == "DEBUFF" ) or ( aExtraType == "DEBUFFBLINK" ) then
        myButton.isDebuff = 1;
        myButton.Debuff = aExtra;

        if ( aExtraType == "DEBUFFBLINK" ) then
            myButton.Blink = 1;
        end
    else
        myButton.isDebuff = 0;
        myButton.Debuff = "";
    end

    if ( aExtraType ) and ( string.sub(aExtraType,1,4) == "BUFF" ) then
        myButton.isBuff = 1;
        myButton.Buff = aExtra;

        local myStartPos_Endblinktime = 0;

        if ( string.find(aExtraType,"BUFFBLINK") ) then
            myButton.Blink = 1;
            if string.len(aExtraType) > string.len("BUFFBLINK") then
                myStartPos_Endblinktime = string.len("BUFFBLINK")+1;
            end
        else
            if string.len(aExtraType) > string.len("BUFF") then
                myStartPos_Endblinktime = string.len("BUFF")+1;
            end
        end

        if ( myStartPos_Endblinktime > 0 ) then
            -- get the attached Endblinktime
            local myEndblinktime = string.sub(aExtraType,myStartPos_Endblinktime);
            if tonumber(myEndblinktime) then
                myButton.BlinkLastSeconds = string.format("%d",myEndblinktime);
            else
                myButton.BlinkLastSeconds = nil;
            end
        else
            myButton.BlinkLastSeconds = nil;
        end
        --ShowMessage("myButton.BlinkLastSeconds: "..CCC(myButton.BlinkLastSeconds));

    else
        myButton.isBuff = 0;
        myButton.Buff = "";
    end

    if ( aExtraType == "ALWAYS" ) then
        myButton.isShowAlways = 1;
    end

    if ( aExtraType == "HEALTH" ) then
        myButton.isHeal = 1;
    elseif ( aExtraType == "HEALTHBLINK" ) then
        myButton.isHeal = 1;
        myButton.Blink = 1;
    else
        myButton.isHeal = 0;
    end

    if XUB_Buttons[aUnit] == nil then
        XUB_Buttons[aUnit] = { x = XUB_XOFFSET , y = XUB_YOFFSET };
    end

    if ( aUnit == "float" ) then
        myButton:SetPoint("TOPLEFT", aFrame, "TOPRIGHT" , XUB_Buttons[aUnit].x , XUB_Buttons[aUnit].y );
    else
        myButton:SetPoint("TOPLEFT", aFrame, XUB_ANCHOR , XUB_Buttons[aUnit].x , XUB_Buttons[aUnit].y );
    end


    if ( aFrameNo == 1 ) then
        XUB_Buttons[aUnit].x = XUB_Buttons[aUnit].x + XUB_ButtonSize;
    end

    myButton.DimState = 0;
    myButton.ShowCountdown = 0;
    myButton.MyCooldown = 0;
end


--
-- Generates a button name according to a unit and index.  This is just the name of the button
-- not the button itself.
--
function XUB_GenerateButtonName(aUnit,aIndex)
    return "XUB_" .. aUnit .. "_" .. aIndex;
end

--
-- Gets the name of a texture according to the name of a spell.  This code will be optimized later
-- by preloading the spell names into a table and doing a direct access call to the table.  It's not
-- critical to rewrite now because the call only occurs when creating buttons.
--
function XUB_GetSpellTextureAndID(aSpellName, aRank)

     local mySaveTexture = "";
     local mySaveID = 0;

     local i=1
     local SpellName,Rank = GetSpellName(i,SpellBookFrame.bookType );

     while ( SpellName ~= nil ) do

         if ( SpellName == aSpellName ) then
             if ( aRank == "" ) then
                 if ( Rank == "" ) then
                     return GetSpellTexture(i,SpellBookFrame.bookType),i
                 else
                     -- Saves the texture and id in case they send us a spell without a rank, we need to find the highest
                     -- ranked spell they have access to.
                     mySaveTexture = GetSpellTexture(i,SpellBookFrame.bookType);
                     mySaveID = i;
                 end
             elseif ( aRank == Rank ) then
                 return GetSpellTexture(i,SpellBookFrame.bookType),i
             end
         end

         i=i+1
         SpellName,Rank = GetSpellName(i,SpellBookFrame.bookType );

     end

     return mySaveTexture,mySaveID;
end



function XUB_Generate_Standard_Tooltip(myButton)

    XUB_GameTooltip:SetOwner(myButton,"ANCHOR_BOTTOMRIGHT");

    if ( myButton.SpellID == 0 ) then
        XUB_GameTooltip:AddLine(myButton.ToolTip,0,1,1,0);
    else
        XUB_GameTooltip:SetSpell(myButton.SpellID,SpellBookFrame.bookType);
        XUB_GameTooltip:AddLine(myButton.ToolTip,0,1,1,0);
    end

    -- Cooldown:
    if ( myButton.isSTATE_COOLDOWN ) then

        local myReadableCooldown = XUB_Generate_CountdownText(myButton);

        if ( myReadableCooldown ~= "" ) then
            XUB_GameTooltip:AddLine("   ",0,1,1,0);
            XUB_GameTooltip:AddLine("remaining Cooldown: " .. myReadableCooldown,0,1,1,0);
        end

    end
end

function XUB_Add_DebugTooltip(myButton)
-- Show additional information in the tooltip if debugging is ON

    XUB_GameTooltip:AddLine("   ",1,1,1,0);
    XUB_GameTooltip:AddLine("XUB-DebugData:",1,1,1,1);
    XUB_GameTooltip:AddLine(" State: "..myButton.State,1,1,0,0);
    XUB_GameTooltip:AddLine(" Attached to frame: "..myButton.AttachedFrame,1,1,0,1);

    local l_mainDestinationUnit = myButton.DestinationUnit
    if ( myButton.Multitarget~= "" ) then
        l_mainDestinationUnit = myButton.Multitarget
    end
    XUB_GameTooltip:AddLine(" Destination unit: "..l_mainDestinationUnit,1,1,0,1);
    if myButton.FullSpellName then XUB_GameTooltip:AddLine(" Fullspellname: "..myButton.FullSpellName,1,1,0,1); end;
    if myButton.SpellID > 0 then XUB_GameTooltip:AddLine(" SpellID: "..myButton.SpellID,1,1,0,1); end;
    if myButton.ExtraType then
        XUB_GameTooltip:AddLine(" ButtonType: " .. myButton.ExtraType,1,1,0,1);
    else
        XUB_GameTooltip:AddLine(" ButtonType: Spell",1,1,0,1);
    end
    if myButton.Blink > 0 then
        XUB_GameTooltip:AddLine(" myButton.Blink: " .. myButton.Blink,1,1,0,1);
    end
    XUB_GameTooltip:AddLine("   ",0,1,1,0);
    --GameTooltip:AddLine(" myButton.isDebuff: " .. myButton.isDebuff,1,1,0,1);
    --GameTooltip:AddLine(" myButton.isBuff: " .. myButton.isBuff,1,1,0,1);
    if myButton.BlinkLastSeconds then
        XUB_GameTooltip:AddLine(" Seconds before expiring to start blinking: " .. myButton.BlinkLastSeconds,1,1,0,1);
    end
    if myButton.RemainingBufftime then
        XUB_GameTooltip:AddLine(" Remaining Seconds for Buff: " .. myButton.RemainingBufftime,1,1,0,1);
    end

    if myButton.State == 0         then XUB_GameTooltip:AddLine(" Button is fully enabled"); end
    if myButton.isSTATE_HEALTHOFF  then XUB_GameTooltip:AddLine(" STATE_HEALTHOFF = 1"); end
    if myButton.isSTATE_BUFFED     then XUB_GameTooltip:AddLine(" STATE_BUFFEDD = 1"); end
    if myButton.isSTATE_DIMMED     then XUB_GameTooltip:AddLine(" STATE_DIMMED = 1"); end
    if myButton.isSTATE_COOLDOWN   then XUB_GameTooltip:AddLine(" STATE_COOLDOWN = 1"); end
    if myButton.isSTATE_NO_ITEMS   then XUB_GameTooltip:AddLine(" STATE_NO_ITEMS = 1"); end
    if myButton.isSTATE_OUTOFMANA  then XUB_GameTooltip:AddLine(" STATE_OUTOFMANA = 1"); end
    if myButton.isSTATE_OUTOFRANGE then XUB_GameTooltip:AddLine(" STATE_OUTOFRANGE = 1"); end
    if myButton.isSTATE_INVALID    then XUB_GameTooltip:AddLine(" STATE_INVALID = 1"); end

end


function XUB_Generate_CooldownTooltip_in_combat(myButton)
-- Show minimal Tooltip containing Cooldown information even if in combat

    local myReadableCooldown = XUB_Generate_CountdownText(myButton);
    if ( myReadableCooldown ~= "" ) then
        XUB_GameTooltip:SetOwner(myButton,"ANCHOR_BOTTOMRIGHT");
        XUB_GameTooltip:AddLine(myReadableCooldown,0,1,1,0);
    end
end


function XUB_UpdateTooltip(myButton)

    if ( XUB_DEBUG > 0 ) then
        XUB_Generate_Standard_Tooltip(myButton);
        XUB_Add_DebugTooltip(myButton);
        XUB_GameTooltip:Show();
    elseif ( XUB_TOOLTIPS == "Always" ) then
        XUB_Generate_Standard_Tooltip(myButton);
        XUB_GameTooltip:Show();
    elseif ( XUB_TOOLTIPS == "Not In Combat" ) then
        if ( not InCombatLockdown() ) then
            XUB_Generate_Standard_Tooltip(myButton);
            XUB_GameTooltip:Show();
        end
    elseif ( XUB_TOOLTIPS == "Show Cooldown Even In Combat" ) then
        if ( not InCombatLockdown() ) then
            XUB_Generate_Standard_Tooltip(myButton);
            XUB_GameTooltip:Show();
        else
            if (myButton.isSTATE_COOLDOWN) then
                XUB_Generate_CooldownTooltip_in_combat(myButton);
                XUB_GameTooltip:Show();
            else
                XUB_GameTooltip:Hide();
            end
        end
    else
        XUB_GameTooltip:Hide();
    end

end


function XUB_ButtonMouseOver(self)

    XUB_MouseOveredButton = self;

    if (self~=nil) and (self.ToolTip ~= nil) then
        if ( XUB_TOOLTIPS ~= "Never" ) or ( XUB_DEBUG > 0 ) then
        -- Show the tooltip if tooltips are to be shown OR Debugging is ON

            if ( self.isSTATE_INVALID == nil) or ( XUB_DEBUG > 0 ) then
            -- Show the tooltip if the button is valid OR Debugging is ON

                XUB_UpdateTooltip(self);
            end
        end
    end

end

function XUB_ButtonMouseExit(self)
    XUB_MouseOveredButton = nil;
    XUB_GameTooltip:Hide();
end

function XUB_ShowFrameNames()
    local frame = EnumerateFrames()
    while frame do
        if frame:IsVisible() and MouseIsOver(frame) then
            ShowMessage(frame:GetName());
        end
        frame = EnumerateFrames(frame)
    end
end

function XUB_Initialize_CountdownLayer_and_Font(myButton)

    local myParent = myButton.CooldownFrame:GetParent();
    local myFontSize = 25;
    local myScale = math.min(myParent:GetWidth() / XUB_ButtonSize, 1);
    local myFont = STANDARD_TEXT_FONT;
    local myText;

    if ( myFontSize * myScale) > 8 then        -- hide the text if the calculated fontsize would be too small

        myText = myButton.CooldownFrame:CreateFontString(nil, "OVERLAY");
        myText:SetPoint("CENTER", myButton.CooldownFrame, "CENTER", 0, 1);
        myText:SetFont(myFont, myFontSize * myScale * 1.2, "OUTLINE");
        myText:SetTextColor(1, 1, 1, 1);      -- white

        myButton.CooldownFrame.text = myText;
        myButton.CooldownFrame.text:SetText("");

    end

end

--
-- Handle any slash commands entered
--
function XUB_SlashCommandHandler(msg)

    local a, b, command, myparameter = string.find( msg, "(%w*)[ ]*([%w/]*)" );

    command = string.lower(command);
    --Debug( "Command" , command );
    --Debug( "myparameter" , myparameter );

    if ( command == "debug" ) then
        if XUB_DEBUG == 1 then
            XUB_DEBUG = 0;
            ShowMessage( "XUB: Debugging is now OFF" );
        else
            XUB_DEBUG = 1;
            ShowMessage( "XUB: Debugging is now ON" );
        end
        return;

    elseif ( command == "showglobalcooldown" ) then

        if (XUB_ShowGlobalCooldown ) then
            XUB_ShowGlobalCooldown = nil;
            ShowMessage( "XUB: Global Cooldown does not start a countdown." );
        else
            XUB_ShowGlobalCooldown = 1;
            ShowMessage( "XUB: Global Cooldown does now start a countdown." );
        end
        return;

    elseif ( command == "showdecimals" ) then

        if (XUB_ShowDecimals ) then
            XUB_ShowDecimals = nil;
            ShowMessage( "XUB: Countdown displayed without decimals." );
        else
            XUB_ShowDecimals = 1;
            ShowMessage( "XUB: Countdown displayed with decimals." );
        end
        return;

    elseif ( command == "useglobaldim" ) then

        if XUB_USE_GLOBALDIM == 1 then
            XUB_USE_GLOBALDIM = 0;
            PBFrame:UnregisterEvent("UNIT_SPELLCAST_START");
            PBFrame:UnregisterEvent("UNIT_SPELLCAST_STOP");
            PBFrame:UnregisterEvent("UNIT_SPELLCAST_FAILED");
            PBFrame:UnregisterEvent("UNIT_SPELLCAST_INTERRUPTED");
            PBFrame:UnregisterEvent("UNIT_SPELLCAST_SUCCEEDED");
            ShowMessage( "XUB: Use Global Dim is now OFF" );
        else
            XUB_USE_GLOBALDIM = 1;
            PBFrame:RegisterEvent("UNIT_SPELLCAST_START");
            ShowMessage( "XUB: Use Global Dim is now ON" );
        end
        return;

    elseif ( command == "changegroupcheck" ) then

        if ( XUB_USE_NEWGROUPCHECK ) then
            XUB_USE_NEWGROUPCHECK = nil;
            ShowMessage( "XUB: XUB uses now the old groupcheck" );
        else
            XUB_USE_NEWGROUPCHECK = 1;
            ShowMessage( "XUB: XUB uses now the new groupcheck" );
        end
        return;

    elseif ( command == "list" ) then

        ShowMessage("BUTTONS (Custom buttons)");
        for i=1,#XUB_ConfigButtons do
            myItems = XUB_ConfigButtons[i];
            ShowMessage("   Name: " .. myItems[1] .. "    Type: " .. myItems[2]);
        end

        ShowMessage("  ");
        ShowMessage("GROUPS");
        for i=1,#XUB_ConfigGroups do
            myItems = XUB_ConfigGroups[i];
            ShowMessage("   Groupname: " .. myItems[1] .. "    Spellname: " .. myItems[2]);
        end

        ShowMessage("  ");
        ShowMessage("PROFILES");
        for i=1,#XUB_ConfigProfiles do
            myItems = XUB_ConfigProfiles[i];
            ShowMessage("   profile Name: " .. myItems[1] .. "    on unit: " .. myItems[2] .. " using group '" .. myItems[3] .. "'" );
        end

        local myUseButtonList = "LeftButtonUp"
        if XUB_UseRightButton then
          myUseButtonList = myUseButtonList .. ", RightButtonUp"
        end
        if XUB_UseMiddleButton then
          myUseButtonList = myUseButtonList .. ", MiddleButtonUp"
        end
        if XUB_UseButton4 then
          myUseButtonList = myUseButtonList .. ", Button4Up"
        end
        if XUB_UseButton5 then
          myUseButtonList = myUseButtonList .. ", Button5Up"
        end
        ShowMessage("  ");
        ShowMessage( "Used Buttons: " )
        ShowMessage( myUseButtonList )

        return;

    end

    if ( InCombatLockdown() ) then
        ShowMessage( "**************************************************************************" );
        ShowMessage( "** CANNOT ISSUE XUB COMMANDS WHILE IN COMBAT **" );
        ShowMessage( "**************************************************************************" );

    elseif ( command == "config" ) or ( command == "c" ) then
        XUB_GenerateDefaultSpells();
        XUB_LoadPreviousSpells();
        XUB_PrepareOptionVariables();
        XUB_UF_RefreshScreenFromSave();

        XUB_Config:Show();

    elseif ( command == "options" ) or ( command == "o" ) then
        XUB_GenerateDefaultSpells();
        XUB_LoadPreviousSpells();
        XUB_PrepareOptionVariables();
        XUB_UF_RefreshScreenFromSave();

        XUB_Options:Show();

    elseif ( command == "unitframes" ) or ( command == "uf" ) then
        XUB_GenerateDefaultSpells();
        XUB_LoadPreviousSpells();
        XUB_PrepareOptionVariables();
        XUB_UF_RefreshScreenFromSave();

        XUB_UnitFrames:Show();

    elseif ( command == "profile" ) or ( command == "p" ) then
        local profile = string.lower(myparameter);

        if ( profile == "" ) then
            profile = XUB_CurrentProfile;
        end
        XUB_Initialize_Raidtable();
        XUB_ApplyProfile(profile);
        XUB_DelayTime = XUB_DelayTime_after_manualProfileChange;

    elseif ( command == "floatwidth" )  or ( command == "fw" ) then
        local floatwidth = myparameter;
        if ( floatwidth ~= "" ) then
            XUB_UF_WIDTH_Float = floatwidth;
            XUB_DelayTime = XUB_DelayTime_after_manualProfileChange;
            XUB_RemoveButtons_for_SingleUnit("float");
            XUB_ApplyProfile_for_SingleUnit(XUB_CurrentProfile,"float",0,"XUB_FloatingFrame");
        else
            ShowMessage( "XUB: Error: No value specified.");
            ShowMessage( " Usage: /XUB floatwidth <value>   or   /XUB fw <value>" );
        end

    elseif ( command == "togglebutton" ) then

        local buttonlist = string.lower(myparameter);

        if string.find(buttonlist, "right" ) then
            if XUB_UseRightButton then
                XUB_UseRightButton = nil
            else
                XUB_UseRightButton = "RightButtonUp"
            end
        end
        if string.find(buttonlist, "middle" ) then
            if XUB_UseMiddleButton then
                XUB_UseMiddleButton = nil
            else
                XUB_UseMiddleButton = "MiddleButtonUp"
            end
        end
        if string.find(buttonlist, "button4" ) then
            if XUB_UseButton4 then
                XUB_UseButton4 = nil
            else
                XUB_UseButton4 = "Button4Up"
            end
        end
        if string.find(buttonlist, "button5" ) then
            if XUB_UseButton5 then
                XUB_UseButton5 = nil
            else
                XUB_UseButton5 = "Button5Up"
            end
        end

        XUB_DelayTime = XUB_DelayTime_after_manualProfileChange;
        XUB_ApplyProfile(XUB_CurrentProfile);

    elseif ( command == "showpartyinraid" ) then

        if ( XUB_ShowPartyInRaid ) then
            XUB_ShowPartyInRaid = nil;
            ShowMessage( "XUB: XUB no longer displays partybuttons while in raid" );
        else
            XUB_ShowPartyInRaid = 1;
            ShowMessage( "XUB: XUB now displays partybuttons while in raid" );
        end

        XUB_DelayTime = XUB_DelayTime_after_manualProfileChange;
        XUB_ApplyProfile(XUB_CurrentProfile);

    else
        command = string.lower( msg );

        ShowMessage( "eXtreme Unit Buttons (XUB)" );
        ShowMessage( " " );
        ShowMessage( "Commands" );
        ShowMessage( "  config (or c)              - Opens the button configuration panel" );
        ShowMessage( "  options (or o)             - Opens the global options window" );
        ShowMessage( "  unitframes (or uf)         - Here you can configure the names of your unit frames" );
        ShowMessage( "  profile (or p) <name>      - Changes the active profile to <name>" );
        ShowMessage( "  profile (or p)             - reapplies the active profile (redraws the buttons)" );
        ShowMessage( "  floatwidth (or fw) <value> - Changes the width for the float frame to <value>" );
        ShowMessage( "  useglobaldim               - toggles Global Dim" );
        ShowMessage( "  togglebutton <value>       - disables the use of buttons eg. 'togglebutton right middle button4 button5'" );
        ShowMessage( "  showpartyinraid            - toggles the displaying of butons for partyframes while in raid" );
        ShowMessage( "  debug                      - toggles Debugging" );
        ShowMessage( " " );
    end

end



function XUB_Fill_GroupUnitLists()

    -- ShowMessage("XUB-debug: Starting 'XUB_Fill_GroupUnitLists'");

    XUB_PlayerRaidUnits = {}
    XUB_PlayerPartyUnits = {}
    local myGroupSize=0;

    if ( GetNumRaidMembers() > 0 ) then
        -- player is in a raid
        myGroupSize = GetNumRaidMembers()
        for i = 1,myGroupSize do
            MyUnit = "raid" .. i;
            MyUnitName = UnitName(MyUnit)
            MyUnitFrame = XUB_RaidTable[MyUnit]
            XUB_PlayerRaidUnits[i] = { MyUnit, MyUnitName, MyUnitFrame }
        end
        if ( XUB_ShowPartyInRaid ) then
        -- if XUB_ShowPartyInRaid is toggled ON
            -- means: player is in a raid, but party frames are shown nevertheless
            myGroupSize = GetNumPartyMembers()
            for i = 1,myGroupSize do
                MyUnit = "party" .. i;
                MyUnitName = UnitName(MyUnit)
                MyUnitFrame = XUB_UF_Party:gsub("!!","0" .. i):gsub("!",i):gsub("#",i):gsub("@",1);
                MyUnitPet = "partypet" ..i;
                MyUnitPetName = UnitName(MyUnitPet);
                MyUnitPetFrame = XUB_UF_PartyPet:gsub("!!","0" .. i):gsub("!",i):gsub("#",i):gsub("@",1);
                XUB_PlayerPartyUnits[i] = { MyUnit, MyUnitName, MyUnitFrame, MyUnitPet, MyUnitPetName, MyUnitPetFrame }
            end
        end
        return
    end

    if ( GetNumPartyMembers() > 0 ) then
        -- player is in a party
        myGroupSize = GetNumPartyMembers()
        for i = 1,myGroupSize do
            MyUnit = "party" .. i;
            MyUnitName = UnitName(MyUnit)
            MyUnitFrame = XUB_UF_Party:gsub("!!","0" .. i):gsub("!",i):gsub("#",i):gsub("@",1);
            MyUnitPet = "partypet" ..i;
            MyUnitPetName = UnitName(MyUnitPet);
            MyUnitPetFrame = XUB_UF_PartyPet:gsub("!!","0" .. i):gsub("!",i):gsub("#",i):gsub("@",1);
            XUB_PlayerPartyUnits[i] = { MyUnit, MyUnitName, MyUnitFrame, MyUnitPet, MyUnitPetName, MyUnitPetFrame }
        end
    end

    -- ShowMessage("XUB-debug: Finished 'XUB_Fill_GroupUnitLists'");
end
